diff -pruN 1.6-2/Changelog 1.7-1/Changelog
--- 1.6-2/Changelog	2019-10-12 08:39:47.000000000 +0000
+++ 1.7-1/Changelog	2020-06-28 23:30:42.000000000 +0000
@@ -120,3 +120,15 @@
     The way to enable code rewrite is now: -Xclang -plugin-arg-clazy -Xclang export-fixes for clang or -export-fixes=somefile.yaml for clazy-standalone
     All other fixit arguments and fixit env variables were removed
     Thanks to Christian Gagneraud for contributing the fixit yaml exporter!
+
+* v1.7 (June 29th, 2020)
+  - New Checks:
+    - overloaded signal
+    - invalid JNI signatures
+    - qstring-comparison-to-implicit-char
+    - qt6-qlatin1string-to-u
+  - connect-non-signal: Fix case where it didn't find the pmf
+  - qstring-arg warns when using QLatin1String::arg(int), as it casts to QChar
+  - Building clazy itself is 30% faster
+  - heap-allocated-small-trivial-type: less false-positives
+
diff -pruN 1.6-2/checks.json 1.7-1/checks.json
--- 1.6-2/checks.json	2019-10-12 08:39:47.000000000 +0000
+++ 1.7-1/checks.json	2020-06-28 23:30:42.000000000 +0000
@@ -1,5 +1,5 @@
 {
-    "available_categories" : ["readability", "qt4", "containers", "qstring", "cpp", "bug", "performance", "deprecation", "qml"],
+    "available_categories" : ["readability", "qt4", "qt6", "containers", "qstring", "cpp", "bug", "performance", "deprecation", "qml"],
     "checks" : [
         {
             "name"  : "qt-keywords",
@@ -20,7 +20,7 @@
             "name"  : "heap-allocated-small-trivial-type",
             "level" : -1,
             "categories" : ["performance"],
-            "visits_stmts" : true
+            "visits_decls" : true
         },
         {
             "name"  : "ifndef-define-typo",
@@ -65,6 +65,18 @@
             ],
             "visits_stmts" : true
         },
+	{
+            "name"  : "qt6-qlatin1string-to-u",
+            "class_name" : "Qt6QLatin1StringToU",
+            "level" : -1,
+            "categories" : ["qt6", "qstring"],
+            "fixits" : [
+                {
+                    "name" : "qt6-qlatin1string-to-u"
+                }
+            ],
+            "visits_stmts" : true
+        },
         {
             "name"   : "tr-non-literal",
             "level"  : -1,
@@ -90,6 +102,12 @@
             "visits_decls" : true
         },
         {
+            "name"  : "overloaded-signal",
+            "level" : 0,
+            "visits_decls" : true,
+            "categories" : ["readability"]
+        },
+        {
             "name"  : "connect-by-name",
             "level" : 0,
             "categories" : ["bug", "readability"],
@@ -103,6 +121,12 @@
             "visits_stmts" : true
         },
         {
+            "name"  : "qstring-comparison-to-implicit-char",
+            "level" : 0,
+            "categories" : ["bug"],
+            "visits_stmts" : true
+        },
+        {
             "name"  : "wrong-qevent-cast",
             "level" : 0,
             "categories" : ["bug"],
@@ -531,7 +555,6 @@
             "name"  : "old-style-connect",
             "level" : 2,
             "minimum_qt_version" : 50500,
-            "ifndef" : "NO_STD_REGEX",
             "categories" : ["performance"],
             "fixits" : [
                 {
@@ -611,6 +634,12 @@
             "level" : -1,
             "categories" : ["containers"],
             "visits_stmts" : true
+        },
+        {
+            "name"  : "jni-signatures",
+            "level" : -1,
+            "categories" : ["bug"],
+            "visits_stmts" : true
         }
     ]
 }
diff -pruN 1.6-2/CheckSources.cmake 1.7-1/CheckSources.cmake
--- 1.6-2/CheckSources.cmake	2019-10-12 08:39:47.000000000 +0000
+++ 1.7-1/CheckSources.cmake	2020-06-28 23:30:42.000000000 +0000
@@ -6,12 +6,14 @@ set(CLAZY_CHECKS_SRCS ${CLAZY_CHECKS_SRC
   ${CMAKE_CURRENT_LIST_DIR}/src/checks/manuallevel/ifndef-define-typo.cpp
   ${CMAKE_CURRENT_LIST_DIR}/src/checks/manuallevel/inefficient-qlist.cpp
   ${CMAKE_CURRENT_LIST_DIR}/src/checks/manuallevel/isempty-vs-count.cpp
+  ${CMAKE_CURRENT_LIST_DIR}/src/checks/manuallevel/jnisignatures.cpp
   ${CMAKE_CURRENT_LIST_DIR}/src/checks/manuallevel/qhash-with-char-pointer-key.cpp
   ${CMAKE_CURRENT_LIST_DIR}/src/checks/manuallevel/qproperty-type-mismatch.cpp
   ${CMAKE_CURRENT_LIST_DIR}/src/checks/manuallevel/qrequiredresult-candidates.cpp
   ${CMAKE_CURRENT_LIST_DIR}/src/checks/manuallevel/qstring-varargs.cpp
   ${CMAKE_CURRENT_LIST_DIR}/src/checks/manuallevel/qt-keywords.cpp
   ${CMAKE_CURRENT_LIST_DIR}/src/checks/manuallevel/qt4-qstring-from-array.cpp
+  ${CMAKE_CURRENT_LIST_DIR}/src/checks/manuallevel/qt6-qlatin1string-to-u.cpp
   ${CMAKE_CURRENT_LIST_DIR}/src/checks/manuallevel/qvariant-template-instantiation.cpp
   ${CMAKE_CURRENT_LIST_DIR}/src/checks/manuallevel/raw-environment-function.cpp
   ${CMAKE_CURRENT_LIST_DIR}/src/checks/manuallevel/reserve-candidates.cpp
@@ -29,6 +31,7 @@ set(CLAZY_CHECKS_SRCS ${CLAZY_CHECKS_SRC
   ${CMAKE_CURRENT_LIST_DIR}/src/checks/level0/lambda-unique-connection.cpp
   ${CMAKE_CURRENT_LIST_DIR}/src/checks/level0/lowercase-qml-type-name.cpp
   ${CMAKE_CURRENT_LIST_DIR}/src/checks/level0/mutable-container-key.cpp
+  ${CMAKE_CURRENT_LIST_DIR}/src/checks/level0/overloaded-signal.cpp
   ${CMAKE_CURRENT_LIST_DIR}/src/checks/level0/qcolor-from-literal.cpp
   ${CMAKE_CURRENT_LIST_DIR}/src/checks/level0/qdatetime-utc.cpp
   ${CMAKE_CURRENT_LIST_DIR}/src/checks/level0/qenums.cpp
@@ -36,6 +39,7 @@ set(CLAZY_CHECKS_SRCS ${CLAZY_CHECKS_SRC
   ${CMAKE_CURRENT_LIST_DIR}/src/checks/level0/qgetenv.cpp
   ${CMAKE_CURRENT_LIST_DIR}/src/checks/level0/qmap-with-pointer-key.cpp
   ${CMAKE_CURRENT_LIST_DIR}/src/checks/level0/qstring-arg.cpp
+  ${CMAKE_CURRENT_LIST_DIR}/src/checks/level0/qstring-comparison-to-implicit-char.cpp
   ${CMAKE_CURRENT_LIST_DIR}/src/checks/level0/qstring-insensitive-allocation.cpp
   ${CMAKE_CURRENT_LIST_DIR}/src/checks/level0/qstring-ref.cpp
   ${CMAKE_CURRENT_LIST_DIR}/src/checks/level0/qt-macros.cpp
@@ -83,7 +87,3 @@ set(CLAZY_CHECKS_SRCS ${CLAZY_CHECKS_SRC
   ${CMAKE_CURRENT_LIST_DIR}/src/checks/level2/static-pmf.cpp
   ${CMAKE_CURRENT_LIST_DIR}/src/checks/level2/virtual-call-ctor.cpp
 )
-
-if(HAS_STD_REGEX OR CLAZY_BUILD_WITH_CLANG)
-  set(CLAZY_CHECKS_SRCS ${CLAZY_CHECKS_SRCS} ${CMAKE_CURRENT_LIST_DIR}/src/checks/level2/old-style-connect.cpp)
-endif()
diff -pruN 1.6-2/clazy.cmake 1.7-1/clazy.cmake
--- 1.6-2/clazy.cmake	2019-10-12 08:39:47.000000000 +0000
+++ 1.7-1/clazy.cmake	2020-06-28 23:30:42.000000000 +0000
@@ -1,7 +1,7 @@
 #!/usr/bin/env sh
 
-libdir=$(readlink -f "$(dirname ${0})/@BIN_RELATIVE_LIBDIR@")
-sharedir=$(readlink -f "$(dirname ${0})/@BIN_RELATIVE_SHAREDIR@")
+libdir=$("@READLINK_CMD@" -f "$(dirname ${0})/@BIN_RELATIVE_LIBDIR@")
+sharedir=$("@READLINK_CMD@" -f "$(dirname ${0})/@BIN_RELATIVE_SHAREDIR@")
 
 HELP() {
   echo "Usage: `basename $0` [options] [clang++-options]"
@@ -38,8 +38,13 @@ VERSION() {
 
 PRLIST() {
   echo ""
-  echo "Checks from level$1. $2:"
-  ls -1 $sharedir/doc/clazy/level$1/README* | awk -F/ '{printf("    %s\n", $NF)}' | sed s/README-// | sed s/\.md$// | sort
+  if ( test -d "$sharedir/doc/clazy/level$1" )
+  then
+    echo "Checks from level$1. $2:"
+    ls -1 $sharedir/doc/clazy/level$1/README* | awk -F/ '{printf("    %s\n", $NF)}' | sed s/README-// | sed s/\.md$// | sort
+  else
+    echo "There are no checkers available for level$1"
+  fi
 }
 
 PRINFO() {
@@ -79,7 +84,7 @@ then
   PRLIST 0 "Very stable checks, 100% safe, no false-positives"
   PRLIST 1 "Mostly stable and safe, rare false-positives"
   PRLIST 2 "Sometimes has false-positives (20-30%)"
-  PRLIST 3 "Not always correct, high rate of false-positives"
+  #PRLIST 3 "Not always correct, high rate of false-positives"
   exit
 fi
 
@@ -107,6 +112,18 @@ then
   ExtraClangOptions="-Xclang -plugin-arg-clazy -Xclang visit-implicit-code"
 fi
 
+case "$CLAZY_CHECKS" in
+  *jni-signatures*)
+    if [ -z "$ANDROID_NDK" ]
+    then
+        echo "To test JNI signatures you need to set ANDROID_NDK to your Android NDK installation."
+        exit
+    fi
+
+    ExtraClangOptions=$ExtraClangOptions" -idirafter"$ANDROID_NDK"/sysroot/usr/include"
+  ;;
+esac
+
 ClazyPluginLib=ClazyPlugin@CMAKE_SHARED_LIBRARY_SUFFIX@
 
 if ( test -f "$libdir/$ClazyPluginLib" )
diff -pruN 1.6-2/cmake/FindClang.cmake 1.7-1/cmake/FindClang.cmake
--- 1.6-2/cmake/FindClang.cmake	2019-10-12 08:39:47.000000000 +0000
+++ 1.7-1/cmake/FindClang.cmake	2020-06-28 23:30:42.000000000 +0000
@@ -62,6 +62,7 @@ if (LLVM_FOUND AND LLVM_LIBRARY_DIRS)
   # note: On Windows there's 'libclang.dll' instead of 'clang.dll' -> search for 'libclang', too
   find_library(CLANG_LIBCLANG_LIB NAMES clang libclang HINTS ${LLVM_LIBRARY_DIRS}) # LibClang: high-level C interface
 
+  FIND_AND_ADD_CLANG_LIB(clang-cpp)
   FIND_AND_ADD_CLANG_LIB(clangFrontend)
   FIND_AND_ADD_CLANG_LIB(clangDriver)
   FIND_AND_ADD_CLANG_LIB(clangCodeGen)
diff -pruN 1.6-2/CMakeLists.txt 1.7-1/CMakeLists.txt
--- 1.6-2/CMakeLists.txt	2019-10-12 08:39:47.000000000 +0000
+++ 1.7-1/CMakeLists.txt	2020-06-28 23:30:42.000000000 +0000
@@ -19,7 +19,7 @@ include("GNUInstallDirs")
 
 # Version setup
 set(CLAZY_VERSION_MAJOR "1")
-set(CLAZY_VERSION_MINOR "6")
+set(CLAZY_VERSION_MINOR "7")
 set(CLAZY_VERSION_PATCH "0")
 set(CLAZY_VERSION "${CLAZY_VERSION_MAJOR}.${CLAZY_VERSION_MINOR}.${CLAZY_VERSION_PATCH}")
 set(CLAZY_PRINT_VERSION "${CLAZY_VERSION_MAJOR}.${CLAZY_VERSION_MINOR}")
@@ -38,6 +38,7 @@ add_definitions(-D_GNU_SOURCE -DHAVE_CLA
 
 option(CLAZY_AST_MATCHERS_CRASH_WORKAROUND "Disable AST Matchers if being built with clang. See bug #392223" ON)
 option(LINK_CLAZY_TO_LLVM "Links the clazy plugin to LLVM. Switch to OFF if your clang binary has all symbols already. Might need to be OFF if your LLVM is static." ON)
+option(APPIMAGE_HACK "Links the clazy plugin to the clang tooling libs only. For some reason this is needed when building on our old CentOS 6.8 to create the AppImage." OFF)
 
 if (CLAZY_AST_MATCHERS_CRASH_WORKAROUND AND "${CMAKE_CXX_COMPILER_ID}" STREQUAL "Clang")
     message("Enabling AST Matchers workaround. Consider building with gcc instead. See bug #392223.")
@@ -52,7 +53,7 @@ if(MSVC)
   # disable trigger-happy warnings from Clang/LLVM headers
   set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /wd4267 /wd4244 /wd4291 /wd4800 /wd4141 /wd4146 /wd4251")
 elseif(CMAKE_COMPILER_IS_GNUCXX OR CMAKE_CXX_COMPILER_ID MATCHES "Clang")
-  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++11 -fno-common -Woverloaded-virtual -Wcast-qual -fno-strict-aliasing -pedantic -Wno-long-long -Wall -W -Wno-unused-parameter -Wwrite-strings -fno-exceptions -fno-rtti")
+  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++14 -fno-common -Woverloaded-virtual -Wcast-qual -fno-strict-aliasing -pedantic -Wno-long-long -Wall -W -Wno-unused-parameter -Wwrite-strings -fno-exceptions -fno-rtti")
 endif()
 
 set(CMAKE_MODULE_LINKER_FLAGS "${CMAKE_MODULE_LINKER_FLAGS} -Wl,-flat_namespace -Wl,-undefined -Wl,suppress")
@@ -66,13 +67,12 @@ endif()
 message("Looking for std::regex support...")
 try_run(RUN_RESULT COMPILE_RESULT ${CMAKE_BINARY_DIR} ${CMAKE_CURRENT_LIST_DIR}/.cmake_has_regex_test.cpp)
 
-if(RUN_RESULT EQUAL 0)
-  set(HAS_STD_REGEX TRUE)
-else()
-  set(HAS_STD_REGEX FALSE)
-  add_definitions(-DNO_STD_REGEX)
-  message("old-style-connect check is disabled due to missing std::regex support")
-  message("Suppressions are disabled due to missing std::regex support")
+if(NOT RUN_RESULT EQUAL 0)
+  message("Using boost::regex instead of std::regex")
+  set(CLAZY_USES_BOOST_REGEX TRUE)
+  add_definitions(-DCLAZY_USES_BOOST_REGEX)
+  find_package(Boost REQUIRED COMPONENTS regex)
+  include_directories(${Boost_INCLUDE_DIRS})
 endif()
 
 include(ClazySources.cmake)
@@ -124,9 +124,17 @@ macro(link_to_llvm name is_standalone)
   if(WIN32)
     target_link_libraries(${name} version.lib)
   endif()
+  # clang >= 9.0 can provide a single shared library instead of split ones
+  if(CLANG_CLANG-CPP_LIB)
+    target_link_libraries(${name} clang-cpp)
+  else()
     target_link_libraries(${name} clangTooling)
     target_link_libraries(${name} clangToolingCore)
     target_link_libraries(${name} ${clang_tooling_refactoring_lib})
+  endif()
+  if (CLAZY_USES_BOOST_REGEX)
+    target_link_libraries(${name} ${Boost_LIBRARIES})
+  endif()
 endmacro()
 
 macro(add_clang_plugin name)
@@ -134,12 +142,24 @@ macro(add_clang_plugin name)
 
   add_library(${name} SHARED ${srcs})
 
+  if(${CMAKE_VERSION} VERSION_GREATER_EQUAL "3.16.0")
+      # 30% speedup
+      target_precompile_headers(${name} PRIVATE src/checkbase.h)
+  endif()
+
   if(SYMBOL_FILE)
     set_target_properties(${name} PROPERTIES LINK_FlAGS "-exported_symbols_list ${SYMBOL_FILE}")
   endif()
 
   if (LINK_CLAZY_TO_LLVM)
     link_to_llvm(${name} FALSE)
+  else()
+    if (APPIMAGE_HACK)
+        # Hack to build on old CentOS 6.8
+        target_link_libraries(${name} clangTooling)
+        target_link_libraries(${name} clangToolingCore)
+        target_link_libraries(${name} ${clang_tooling_refactoring_lib})
+    endif()
   endif()
 
   if(MSVC)
@@ -167,6 +187,14 @@ if (NOT CLAZY_BUILD_WITH_CLANG)
   set(SHARE_INSTALL_DIR ${CMAKE_INSTALL_DATAROOTDIR} CACHE STRING "Share directory name")
 
   if(NOT WIN32)
+    if(APPLE)
+      find_program(READLINK_CMD greadlink)
+    else()
+      find_program(READLINK_CMD readlink)
+    endif()
+    if(NOT READLINK_CMD)
+      message(FATAL_ERROR "Could not find a proper readlink.  On Mac OSX you should install coreutils using homebrew in order to use the GNU readlink")
+    endif()
     file(RELATIVE_PATH BIN_RELATIVE_LIBDIR "${CMAKE_INSTALL_FULL_BINDIR}" "${CMAKE_INSTALL_FULL_LIBDIR}")
     file(RELATIVE_PATH BIN_RELATIVE_SHAREDIR "${CMAKE_INSTALL_FULL_BINDIR}" "${CMAKE_INSTALL_FULL_DATAROOTDIR}")
     configure_file(${CMAKE_CURRENT_LIST_DIR}/clazy.cmake ${CMAKE_BINARY_DIR}/clazy @ONLY)
diff -pruN 1.6-2/debian/changelog 1.7-1/debian/changelog
--- 1.6-2/debian/changelog	2019-10-19 22:14:09.000000000 +0000
+++ 1.7-1/debian/changelog	2020-07-01 06:06:18.000000000 +0000
@@ -1,3 +1,22 @@
+clazy (1.7-1) unstable; urgency=medium
+
+  [ Pino Toscano ]
+  * New upstream release.
+  * Update the patches:
+    - select-clangpp.diff: refresh
+  * Update lintian overrides.
+  * Add Rules-Requires-Root: no.
+  * Bump Standards-Version to 4.5.0, no changes required.
+  * Run again the inefficient-qlist check on i386, as it was fixed upstream.
+  * Change the python3 build dependency to python3:any, as Python is needed
+    only as build tool.
+  * Update copyright.
+
+  [ Alexander Volkov ]
+  * Don't install needless build dependencies when nocheck profile is enabled.
+
+ -- Pino Toscano <pino@debian.org>  Wed, 01 Jul 2020 08:06:18 +0200
+
 clazy (1.6-2) unstable; urgency=medium
 
   * Update copyright.
diff -pruN 1.6-2/debian/clazy.lintian-overrides 1.7-1/debian/clazy.lintian-overrides
--- 1.6-2/debian/clazy.lintian-overrides	2019-02-01 16:04:50.000000000 +0000
+++ 1.7-1/debian/clazy.lintian-overrides	2020-06-30 21:58:53.000000000 +0000
@@ -1,8 +1,8 @@
 # Clang plugin
 clazy: package-name-doesnt-match-sonames ClazyPlugin
 # Clang plugin
-clazy: shlib-without-versioned-soname usr/lib/*/ClazyPlugin.so ClazyPlugin.so
+clazy: shared-library-lacks-version usr/lib/*/ClazyPlugin.so ClazyPlugin.so
 # Clang plugin
 clazy: no-symbols-control-file usr/lib/*/ClazyPlugin.so
 # Clang plugin
-clazy: package-must-activate-ldconfig-trigger usr/lib/*/ClazyPlugin.so
+clazy: lacks-ldconfig-trigger usr/lib/*/ClazyPlugin.so
diff -pruN 1.6-2/debian/control 1.7-1/debian/control
--- 1.6-2/debian/control	2019-10-19 05:22:48.000000000 +0000
+++ 1.7-1/debian/control	2020-06-30 23:07:38.000000000 +0000
@@ -11,10 +11,11 @@ Build-Depends: chrpath,
                debhelper-compat (= 12),
                libclang-dev (>= 1:5.0~),
                llvm-dev (>= 1:5.0~),
-               python3,
-               qtbase5-dev,
-               qtdeclarative5-dev,
-Standards-Version: 4.4.1
+               python3:any <!nocheck>,
+               qtbase5-dev <!nocheck>,
+               qtdeclarative5-dev <!nocheck>,
+Standards-Version: 4.5.0
+Rules-Requires-Root: no
 Homepage: https://www.kdab.com/clazy-video/
 Vcs-Git: https://salsa.debian.org/qt-kde-team/extras/clazy.git
 Vcs-Browser: https://salsa.debian.org/qt-kde-team/extras/clazy
diff -pruN 1.6-2/debian/copyright 1.7-1/debian/copyright
--- 1.6-2/debian/copyright	2019-10-19 05:11:35.000000000 +0000
+++ 1.7-1/debian/copyright	2020-07-01 06:05:07.000000000 +0000
@@ -3,14 +3,16 @@ Upstream-Name: clazy
 Source: https://download.kde.org/stable/clazy/
 
 Files: *
-Copyright: 2015-2019 Sergio Martins <smartins@kde.org>
-           2015, 2016, 2019 Klarälvdalens Datakonsult AB, a KDAB Group company, info@kdab.com
+Copyright: 2015-2020 Sergio Martins <smartins@kde.org>
+           2015, 2016, 2019-2020 Klarälvdalens Datakonsult AB, a KDAB Group company, info@kdab.com
            2015 Nyall Dawson <nyall.dawson@gmail.com>
            2015 Mathias Hasselmann <mathias.hasselmann@kdab.com>
            2015 Albert Astals Cid <albert.astals@canonical.com>
            2019 Christian Gagneraud <chgans@gmail.com>
            2019 Jean-Michaël Celerier <jeanmichael.celerier@gmail.com>
            2019 Nikolai Kosjar <nikolai.kosjar@qt.io>
+           2020 Lucie Gerard <lucie.gerard@qt.io>
+           2020 The Qt Company Ltd.
 License: LGPL-2+
 
 Files: docs/*
@@ -38,7 +40,7 @@ License: BSD-2-Clause
 
 Files: debian/*
 Copyright: 2018 Scarlett Moore <sgclark@kde.org>
-           2018 Pino Toscano <pino@debian.org>
+           2018-2020 Pino Toscano <pino@debian.org>
 License: LGPL-2+
 
 License: CC0-1.0
diff -pruN 1.6-2/debian/patches/select-clangpp.diff 1.7-1/debian/patches/select-clangpp.diff
--- 1.6-2/debian/patches/select-clangpp.diff	2019-10-17 12:00:49.000000000 +0000
+++ 1.7-1/debian/patches/select-clangpp.diff	2020-06-30 21:33:09.000000000 +0000
@@ -7,7 +7,7 @@ Last-Update: 2019-02-01
 
 --- a/CMakeLists.txt
 +++ b/CMakeLists.txt
-@@ -48,6 +48,10 @@ if(NOT CLAZY_BUILD_WITH_CLANG AND MSVC A
+@@ -49,6 +49,10 @@ if(NOT CLAZY_BUILD_WITH_CLANG AND MSVC A
    message(FATAL_ERROR "\nOn MSVC you need to pass -DCLANG_LIBRARY_IMPORT=C:/path/to/llvm-build/lib/clang.lib to cmake when building Clazy.\nAlso make sure you've built LLVM with -DLLVM_EXPORT_SYMBOLS_FOR_PLUGINS=ON")
  endif()
  
@@ -29,7 +29,7 @@ Last-Update: 2019-02-01
  }
  
  PRLIST() {
-@@ -133,5 +133,5 @@ then
+@@ -150,5 +150,5 @@ then
      $(dirname $0)/bin/clazy-standalone "$@"
    fi
  else
diff -pruN 1.6-2/debian/rules 1.7-1/debian/rules
--- 1.6-2/debian/rules	2019-10-19 22:08:51.000000000 +0000
+++ 1.7-1/debian/rules	2020-06-30 23:01:08.000000000 +0000
@@ -12,12 +12,6 @@ ifeq ($(DEB_HOST_ARCH),$(findstring $(DE
 export DEB_LDFLAGS_MAINT_APPEND = -Wl,--no-as-needed -latomic -Wl,--as-needed
 endif
 
-# wrong size reported, although the test correctly identifies the issue
-# https://bugs.kde.org/show_bug.cgi?id=413169
-ifeq ($(DEB_HOST_ARCH),i386)
-RUN_TESTS_ARGS += --exclude inefficient-qlist
-endif
-
 # keep the "++" at the end, to make sure the tool used is the C++ frontend
 CLANGPP=$(shell realpath $$(env PATH=$$(echo "$$PATH" | sed -r -e 's|/usr/lib/ccache/?:||') which clang++))++
 
diff -pruN 1.6-2/dev-scripts/docker/AppImage/clazy.AppDir/AppRun 1.7-1/dev-scripts/docker/AppImage/clazy.AppDir/AppRun
--- 1.6-2/dev-scripts/docker/AppImage/clazy.AppDir/AppRun	1970-01-01 00:00:00.000000000 +0000
+++ 1.7-1/dev-scripts/docker/AppImage/clazy.AppDir/AppRun	2020-06-28 23:30:42.000000000 +0000
@@ -0,0 +1,7 @@
+#!/bin/sh
+
+HERE="$(dirname "$(readlink -f "${0}")")"
+export LD_LIBRARY_PATH=${HERE}/usr/lib:$LD_LIBRARY_PATH
+export DYLD_LIBRARY_PATH=${HERE}/usr/lib:$DYLD_LIBRARY_PATH
+export PATH=${HERE}/usr/bin:$PATH
+exec "${HERE}/usr/bin/clazy" "$@"
diff -pruN 1.6-2/dev-scripts/docker/AppImage/clazy.AppDir/clazy.desktop 1.7-1/dev-scripts/docker/AppImage/clazy.AppDir/clazy.desktop
--- 1.6-2/dev-scripts/docker/AppImage/clazy.AppDir/clazy.desktop	1970-01-01 00:00:00.000000000 +0000
+++ 1.7-1/dev-scripts/docker/AppImage/clazy.AppDir/clazy.desktop	2020-06-28 23:30:42.000000000 +0000
@@ -0,0 +1,28 @@
+[Desktop Entry]
+Name=Clazy
+Name[ca]=Clazy
+Name[ca@valencia]=Clazy
+Name[cs]=Clazy
+Name[de]=Clazy
+Name[en_GB]=Clazy
+Name[es]=Clazy
+Name[et]=Clazy
+Name[fr]=Clazy
+Name[it]=Clazy
+Name[ko]=Clazy
+Name[lt]=Clazy
+Name[nl]=Clazy
+Name[nn]=Clazy
+Name[pt]=Clazy
+Name[pt_BR]=Clazy
+Name[ru]=Clazy
+Name[sk]=Clazy
+Name[sl]=Clazy
+Name[sv]=Clazy
+Name[uk]=Clazy
+Name[x-test]=xxClazyxx
+Name[zh_TW]=Clazy
+Exec=clazy
+Icon=clazy
+Type=Application
+Categories=Development;
Binary files 1.6-2/dev-scripts/docker/AppImage/clazy.AppDir/clazy.png and 1.7-1/dev-scripts/docker/AppImage/clazy.AppDir/clazy.png differ
diff -pruN 1.6-2/dev-scripts/docker/AppImage/Dockerfile 1.7-1/dev-scripts/docker/AppImage/Dockerfile
--- 1.6-2/dev-scripts/docker/AppImage/Dockerfile	1970-01-01 00:00:00.000000000 +0000
+++ 1.7-1/dev-scripts/docker/AppImage/Dockerfile	2020-06-28 23:30:42.000000000 +0000
@@ -0,0 +1,58 @@
+FROM centos:6.8
+MAINTAINER Sergio Martins (sergio.martins@kdab.com)
+
+WORKDIR /
+RUN yum update -y
+RUN yum install -y git wget
+
+RUN wget http://people.centos.org/tru/devtools-2/devtools-2.repo -O /etc/yum.repos.d/devtools-2.repo
+RUN yum install -y devtoolset-2-gcc devtoolset-2-binutils devtoolset-2-gcc-c++
+
+ENV PATH=/opt/rh/devtoolset-2/root/usr/bin/:$PATH
+
+# Copy appdir template
+ADD clazy.AppDir /clazy.AppDir/
+
+# Build Python
+RUN wget https://www.python.org/ftp/python/2.7.16/Python-2.7.16.tgz
+RUN tar xzf Python-2.7.16.tgz
+WORKDIR /Python-2.7.16
+RUN ./configure --enable-optimizations
+RUN make -j8 altinstall
+RUN ln -sf /usr/local/bin/python2.7 /usr/local/bin/python
+
+#Build CMake
+WORKDIR /
+RUN git clone https://github.com/Kitware/CMake.git
+WORKDIR /CMake
+RUN git checkout v3.15.4
+RUN ./configure --prefix=/usr/
+RUN make -j8
+RUN make install
+
+#Build LLVM
+WORKDIR /
+RUN wget -O - https://github.com/llvm/llvm-project/tarball/llvmorg-9.0.0 | tar xz
+RUN mv llvm-llvm-project-* llvm-project
+WORKDIR /llvm-project/
+RUN echo "LLVM sha1: `git rev-parse HEAD`" > /clazy.AppDir/sha1
+
+RUN mkdir /root/build_llvm/
+WORKDIR /root/build_llvm/
+RUN cmake -DCMAKE_INSTALL_PREFIX=/usr/ -DLLVM_INCLUDE_EXAMPLES=OFF -DLLVM_TARGETS_TO_BUILD="X86" -DLLVM_ENABLE_PROJECTS="clang;clang-tools-extra" -DBUILD_SHARED_LIBS=OFF -DCMAKE_BUILD_TYPE=Release -DLLVM_TEMPORARILY_ALLOW_OLD_TOOLCHAIN=ON -DCLANG_ENABLE_CLANGD=OFF /llvm-project/llvm/
+RUN make -j8
+RUN make install
+RUN make DESTDIR=/clazy.AppDir install
+RUN rm -rf /clazy.AppDir/usr/include/
+RUN rm -rf /clazy.AppDir/usr/share/
+RUN rm -rf /clazy.AppDir/usr/lib/*.a
+RUN rm -rf /clazy.AppDir/usr/lib/*.so*
+RUN rm -rf /clazy.AppDir/usr/lib/cmake
+RUN rm -rf /clazy.AppDir/usr/bin/ll*
+WORKDIR /clazy.AppDir/usr/bin/
+RUN rm -rf bugpoint clang-change-namespace clang-doc clang-format verify-uselistorder c-index-test clang-include-fixer clang-query clang-rename clang-scan-deps diagtool find-all-symbols hmaptool obj2yaml sancov scan-build verify-uselistorderc-index-test clang-check clang-extdef-mapping clang-import-test clang-offload-bundler clang-refactor clang-reorder-fields clang-tidy dsymutil git-clang-format modularize opt sanstats scan-view yaml2obj
+RUN chmod +x *
+
+#Clone clazy
+WORKDIR /
+RUN git clone https://github.com/KDE/clazy.git
diff -pruN 1.6-2/dev-scripts/docker/make_appimage.sh 1.7-1/dev-scripts/docker/make_appimage.sh
--- 1.6-2/dev-scripts/docker/make_appimage.sh	2019-10-12 08:39:47.000000000 +0000
+++ 1.7-1/dev-scripts/docker/make_appimage.sh	2020-06-28 23:30:42.000000000 +0000
@@ -5,20 +5,12 @@
 #   $1 clazy sha1 to build
 #   $2 user uid to chown the files to before leaving docker
 
-PATH=/opt/rh/python27/root/usr/bin:/opt/rh/devtoolset-6/root/usr/bin:/usr/local/sbin:/usr/local/bin:/usr/sbin:/usr/bin:/sbin:/bin
-
-# edit here the LLVM version used
-PATH=$PATH:/llvm900/bin/
-
 CC=gcc
 CXX=g++
 
-cp -r /clazy.AppDir /tmp/clazy_work/
+mkdir /tmp/clazy_work/
+cp -r /clazy.AppDir/ /tmp/clazy_work/
 
-cd /llvm
-echo "LLVM sha1: `git rev-parse HEAD`" > /tmp/clazy_work/clazy.AppDir/sha1
-cd tools/clang
-echo "Clang sha1: `git rev-parse HEAD`" >> /tmp/clazy_work/clazy.AppDir/sha1
 
 cd /clazy
 echo "Clazy sha1: `git rev-parse HEAD`" >> /tmp/clazy_work/clazy.AppDir/sha1
@@ -33,7 +25,7 @@ echo "Checking out $1..."
 git checkout $1
 
 echo "Building..."
-cmake3 -DCMAKE_BUILD_TYPE=Release -DLINK_CLAZY_TO_LLVM=OFF -DCMAKE_INSTALL_PREFIX=/tmp/clazy_work/clazy.AppDir/usr . && make -j12 && make install
+cmake -DCMAKE_BUILD_TYPE=Release -DAPPIMAGE_HACK=ON -DLINK_CLAZY_TO_LLVM=OFF -DCMAKE_INSTALL_PREFIX=/tmp/clazy_work/clazy.AppDir/usr . && make -j12 && make install
 
 echo "Fixing permissions..."
 chown -R $2 /tmp/clazy_work/clazy.AppDir/
diff -pruN 1.6-2/dev-scripts/generate.py 1.7-1/dev-scripts/generate.py
--- 1.6-2/dev-scripts/generate.py	2019-10-12 08:39:47.000000000 +0000
+++ 1.7-1/dev-scripts/generate.py	2020-06-28 23:30:42.000000000 +0000
@@ -317,21 +317,12 @@ void CheckManager::registerChecks()
 #-------------------------------------------------------------------------------
 def generate_cmake_file(checks):
     text = "set(CLAZY_CHECKS_SRCS ${CLAZY_CHECKS_SRCS}\n"
-    checks_with_regexp = []
     for level in [-1, 0, 1, 2, 3]:
         for check in checks:
             if check.level == level:
                 text += "  ${CMAKE_CURRENT_LIST_DIR}/src/" + check.qualified_cpp_filename() + "\n"
-                if check.ifndef == "NO_STD_REGEX":
-                    checks_with_regexp.append(check)
     text += ")\n"
 
-    if checks_with_regexp:
-        text += "\nif(HAS_STD_REGEX OR CLAZY_BUILD_WITH_CLANG)\n"
-        for check in checks_with_regexp:
-            text += "  set(CLAZY_CHECKS_SRCS ${CLAZY_CHECKS_SRCS} ${CMAKE_CURRENT_LIST_DIR}/src/" + check.qualified_cpp_filename() + ")\n"
-        text += "endif()\n"
-
     filename = clazy_source_path() + "CheckSources.cmake"
     old_text = read_file(filename)
     if old_text != text:
diff -pruN 1.6-2/dev-scripts/make_appimage.py 1.7-1/dev-scripts/make_appimage.py
--- 1.6-2/dev-scripts/make_appimage.py	2019-10-12 08:39:47.000000000 +0000
+++ 1.7-1/dev-scripts/make_appimage.py	2020-06-28 23:30:42.000000000 +0000
@@ -47,7 +47,7 @@ def prepare_folder():
     os.mkdir(WORK_FOLDER)
 
 def make_appimage_in_docker():
-    cmd = 'docker run -i -t -v %s:%s %s %s' % (WORK_FOLDER, WORK_FOLDER, DOCKER_IMAGE, 'bash -c "/clazy/dev-scripts/docker/make_appimage.sh %s %s"' % (CLAZY_SHA1, str(os.getuid())))
+    cmd = 'docker run -i -t -v %s:%s %s %s' % (WORK_FOLDER, WORK_FOLDER, DOCKER_IMAGE, 'bash -c "cd /clazy/ && git pull && /clazy/dev-scripts/docker/make_appimage.sh %s %s"' % (CLAZY_SHA1, str(os.getuid())))
     if not run_command(cmd):
         print 'Error running docker. Make sure docker is running and that you have ' + DOCKER_IMAGE
 
@@ -65,7 +65,7 @@ def run_tests():
     os.chdir(clazy_source_directory() + '/tests/')
     os.environ['CLAZY_CXX'] = '/tmp/clazy_work//Clazy-x86_64.AppImage'
     os.environ['CLAZYSTANDALONE_CXX'] = '/tmp/clazy_work//Clazy-x86_64.AppImage --standalone'
-    return run_command("./run_tests.py --verbose")
+    return run_command("./run_tests.py --verbose --exclude clazy,old-style-connect") # Centos68 doesn't have std::regexp support, so the suppressions and old-style-connect checks fail. TODO: Port to llvm regexps.
 
 
 if len(sys.argv) != 2:
diff -pruN 1.6-2/dev-scripts/make_windows_package.py 1.7-1/dev-scripts/make_windows_package.py
--- 1.6-2/dev-scripts/make_windows_package.py	2019-10-12 08:39:47.000000000 +0000
+++ 1.7-1/dev-scripts/make_windows_package.py	2020-06-28 23:30:42.000000000 +0000
@@ -5,8 +5,8 @@ from shutil import copyfile
 
 #--------------------------------------------------
 # Change here:
-CLAZY_VERSION = '1.6'
-CANDIDATE_SHA1 = 'v1.6'
+CLAZY_VERSION = '1.7'
+CANDIDATE_SHA1 = 'v1.7'
 PACKAGE_DIR = '/c/d/clazy-msvc-package/'
 PACKAGE_DIR_WIN = 'c:\\d\\clazy-msvc-package\\'
 #--------------------------------------------------
diff -pruN 1.6-2/docs/checks/README-copyable-polymorphic.md 1.7-1/docs/checks/README-copyable-polymorphic.md
--- 1.6-2/docs/checks/README-copyable-polymorphic.md	2019-10-12 08:39:47.000000000 +0000
+++ 1.7-1/docs/checks/README-copyable-polymorphic.md	2020-06-28 23:30:42.000000000 +0000
@@ -21,7 +21,7 @@ void printNumber(Base b)
 
 (...)
 Derived d;
-foo(d);
+printNumber(d);
 
 ```
 
diff -pruN 1.6-2/docs/checks/README-heap-allocated-small-trivial-type.md 1.7-1/docs/checks/README-heap-allocated-small-trivial-type.md
--- 1.6-2/docs/checks/README-heap-allocated-small-trivial-type.md	2019-10-12 08:39:47.000000000 +0000
+++ 1.7-1/docs/checks/README-heap-allocated-small-trivial-type.md	2020-06-28 23:30:42.000000000 +0000
@@ -4,6 +4,9 @@ Warns when you're allocating small trivi
 Example:
 ```
     auto p = new QPoint(1, 1);
+    /// ... p just used locally in the scope
 ```
 
-Unneeded memory allocations are costly.
+Unneeded memory allocations are costly. Make sure there's no change in behaviour
+before fixing these warnings. This check is not enabled by default since there's
+a certain amount of known false-positives.
diff -pruN 1.6-2/docs/checks/README-jni-signatures.md 1.7-1/docs/checks/README-jni-signatures.md
--- 1.6-2/docs/checks/README-jni-signatures.md	1970-01-01 00:00:00.000000000 +0000
+++ 1.7-1/docs/checks/README-jni-signatures.md	2020-06-28 23:30:42.000000000 +0000
@@ -0,0 +1,11 @@
+# jni-signatures
+
+Tries to find invalid JNI signatures in QAndroidJniObject usage. Those will lead to runtime errors.
+
+#### Example
+```
+    QAndroidJniObject::callStaticMethod("toString", "()Ljava/lang/String"); // Should be '()Ljava/lang/String;'
+```
+
+#### Pitfalls
+For this check to work you need to set the ANDROID_NDK environment variable to your Android NDK installation.
diff -pruN 1.6-2/docs/checks/README-overloaded-signal.md 1.7-1/docs/checks/README-overloaded-signal.md
--- 1.6-2/docs/checks/README-overloaded-signal.md	1970-01-01 00:00:00.000000000 +0000
+++ 1.7-1/docs/checks/README-overloaded-signal.md	2020-06-28 23:30:42.000000000 +0000
@@ -0,0 +1,10 @@
+# overloaded-signal
+
+Warns when signals are overloaded (two signals with different signature in the same class).
+Overloaded signals requires annoying casts during connects, which are not very elegant.
+
+Example of ugly connect:
+```
+connect(process, QOverload<int, QProcess::ExitStatus>::of(&QProcess::finished),
+      [=](int exitCode, QProcess::ExitStatus exitStatus){ /* ... */ });
+```
diff -pruN 1.6-2/docs/checks/README-qstring-arg.md 1.7-1/docs/checks/README-qstring-arg.md
--- 1.6-2/docs/checks/README-qstring-arg.md	2019-10-12 08:39:47.000000000 +0000
+++ 1.7-1/docs/checks/README-qstring-arg.md	2020-06-28 23:30:42.000000000 +0000
@@ -1,13 +1,16 @@
 # qstring-arg
 
-Implements two warnings:
+Implements three warnings:
 
 1. Detects when you're using chained `QString::arg()` calls and should instead use the multi-arg overload to save memory allocations
 
         QString("%1 %2").arg(a).arg(b);
         QString("%1 %2").arg(a, b); // one less temporary heap allocation
 
-2. Detects when you're using misleading `QString::arg()` overloads
+2. Detects when you're passing an integer to QLatin1String::arg() as that gets implicitly cast to QChar.
+It's preferable to state your intention and cast to QChar explicitly.
+
+3. Detects when you're using misleading `QString::arg()` overloads
 
         QString arg(qlonglong a, int fieldwidth = 0, int base = 10, QChar fillChar = QLatin1Char(' ')) const
         QString arg(qulonglong a, int fieldwidth = 0, int base = 10, QChar fillChar = QLatin1Char(' ')) const
diff -pruN 1.6-2/docs/checks/README-qstring-comparison-to-implicit-char.md 1.7-1/docs/checks/README-qstring-comparison-to-implicit-char.md
--- 1.6-2/docs/checks/README-qstring-comparison-to-implicit-char.md	1970-01-01 00:00:00.000000000 +0000
+++ 1.7-1/docs/checks/README-qstring-comparison-to-implicit-char.md	2020-06-28 23:30:42.000000000 +0000
@@ -0,0 +1,10 @@
+# qstring-comparison-to-implicit-char
+
+Finds cases where QString is being compared to an int literal but it's casting to QChar implicitly.
+This is often a mistake as the developer intended to compare against the string representation of the integer.
+
+Example:
+```
+if (myString == 5000) { // warning: QString being compared to implicit QChar
+}
+```
diff -pruN 1.6-2/docs/checks/README-qt6-qlatin1string-to-u.md 1.7-1/docs/checks/README-qt6-qlatin1string-to-u.md
--- 1.6-2/docs/checks/README-qt6-qlatin1string-to-u.md	1970-01-01 00:00:00.000000000 +0000
+++ 1.7-1/docs/checks/README-qt6-qlatin1string-to-u.md	2020-06-28 23:30:42.000000000 +0000
@@ -0,0 +1,3 @@
+# qt6-qlatin1string-to-u
+
+Warns when using `QLatin1String` and replaces it with `u`.
diff -pruN 1.6-2/docs/man/clazy.pod 1.7-1/docs/man/clazy.pod
--- 1.6-2/docs/man/clazy.pod	2019-10-12 08:39:47.000000000 +0000
+++ 1.7-1/docs/man/clazy.pod	2020-06-28 23:30:42.000000000 +0000
@@ -202,6 +202,9 @@ B<CLAZY_NO_WERROR> - if this is variable
 even if the -Werror compiler option is specified.  This is useful if you want to use -Werror
 only for the regular gcc/clang warnings but not for clazy warnings.
 
+B<CLAZY_CHECKS_AS_ERRORS> - comma-separated list of checks that will be promoted
+to compiler errors. Note that this does not enable the checks specified here.
+
 =head1 COPYRIGHT AND LICENSE
 
 Copyright (C) 2015-2017 Klaralvdalens Datakonsult AB, a KDAB Group company, <info@kdab.com>
diff -pruN 1.6-2/.gitignore 1.7-1/.gitignore
--- 1.6-2/.gitignore	2019-10-12 08:39:47.000000000 +0000
+++ 1.7-1/.gitignore	2020-06-28 23:30:42.000000000 +0000
@@ -33,3 +33,6 @@ CPackSourceConfig.cmake
 *.yaml
 *.fixed
 checks.json.h
+.ninja*
+*.ninja
+.cmake
diff -pruN 1.6-2/org.kde.clazy.metainfo.xml 1.7-1/org.kde.clazy.metainfo.xml
--- 1.6-2/org.kde.clazy.metainfo.xml	2019-10-12 08:39:47.000000000 +0000
+++ 1.7-1/org.kde.clazy.metainfo.xml	2020-06-28 23:30:42.000000000 +0000
@@ -4,9 +4,66 @@
   <metadata_license>CC0-1.0</metadata_license>
   <project_license>LGPL-2.1-or-later</project_license>
   <name>Clazy</name>
+  <name xml:lang="ca">Clazy</name>
+  <name xml:lang="ca-valencia">Clazy</name>
+  <name xml:lang="cs">Clazy</name>
+  <name xml:lang="en-GB">Clazy</name>
+  <name xml:lang="es">Clazy</name>
+  <name xml:lang="et">Clazy</name>
+  <name xml:lang="eu">Clazy</name>
+  <name xml:lang="fr">Clazy</name>
+  <name xml:lang="it">Clazy</name>
+  <name xml:lang="ko">Clazy</name>
+  <name xml:lang="lt">Clazy</name>
+  <name xml:lang="nl">Clazy</name>
+  <name xml:lang="nn">Clazy</name>
+  <name xml:lang="pt">Clazy</name>
+  <name xml:lang="pt-BR">Clazy</name>
+  <name xml:lang="sk">Clazy</name>
+  <name xml:lang="sl">Clazy</name>
+  <name xml:lang="sv">Clazy</name>
+  <name xml:lang="uk">Clazy</name>
+  <name xml:lang="x-test">xxClazyxx</name>
+  <name xml:lang="zh-TW">Clazy</name>
   <summary>A Clang compiler plugin which emits warnings related to Qt best practices</summary>
+  <summary xml:lang="ca">Un connector del compilador Clang que emet avisos relacionats amb les millors pràctiques de les Qt</summary>
+  <summary xml:lang="ca-valencia">Un connector del compilador Clang que emet avisos relacionats amb les millors pràctiques de les Qt</summary>
+  <summary xml:lang="en-GB">A Clang compiler plugin which emits warnings related to Qt best practices</summary>
+  <summary xml:lang="es">Un complemento del compilador Clang que emite advertencias relacionadas con las prácticas adecuadas de Qt</summary>
+  <summary xml:lang="et">Clangi kompilaatori plugin, mis väljastab Qt parima praktikaga seonduvaid hoiatusi</summary>
+  <summary xml:lang="eu">Clang konpilatzailearen plugin bat, Qt-ren gaineko praktika onenen abisuak igortzen dituena</summary>
+  <summary xml:lang="fr">Un module externe pour le compilateur Clang émettant des avertissements concernant les bonnes pratiques Qt.</summary>
+  <summary xml:lang="it">Un'estensione per il compilatore Clang che emette avvisi relativi alle migliori pratiche per Qt</summary>
+  <summary xml:lang="ko">Qt 권고 사항과 관련된 경고를 출력하는 Clang 컴파일러 플러그인</summary>
+  <summary xml:lang="lt">Clang kompiliatoriaus papildinys, kuris parodo įspėjimus, susijusius su Qt gerąja patirtimi</summary>
+  <summary xml:lang="nl">Een Clang-compilerplug-in die waarschuwingen uitstuurt gerelateerd aan de beste praktijken van Qt</summary>
+  <summary xml:lang="nn">Kompilatortillegg for Clang som viser åtvaringar knytte til mønsterpraksis for Qt-utvikling</summary>
+  <summary xml:lang="pt">Um 'plugin' do compilador Clang que emite avisos relacionados com as boas práticas do Qt</summary>
+  <summary xml:lang="pt-BR">Um plugin do compilador Clang que emite avisos relacionados às melhores práticas do Qt</summary>
+  <summary xml:lang="sl">Vtičnik za prevajalnik Clang, ki oddaja opozorila, povezana z najboljšimi praksami Qt</summary>
+  <summary xml:lang="sv">Ett insticksprogram för Clang-kompilatorn som producerar varningar relaterade till bästa praxis för Qt</summary>
+  <summary xml:lang="uk">Додаток до компілятора Clang, який попереджає про порушення правил правильного програмування з використанням Qt</summary>
+  <summary xml:lang="x-test">xxA Clang compiler plugin which emits warnings related to Qt best practicesxx</summary>
   <description>
     <p>Clazy is a clang compiler plugin which emits warnings related to Qt best practices.</p>
+    <p xml:lang="ca">El Clazy és un connector del compilador Clang que emet avisos relacionats amb les millors pràctiques de les Qt.</p>
+    <p xml:lang="ca-valencia">El Clazy és un connector del compilador Clang que emet avisos relacionats amb les millors pràctiques de les Qt.</p>
+    <p xml:lang="en-GB">Clazy is a clang compiler plugin which emits warnings related to Qt best practices.</p>
+    <p xml:lang="es">Clazy es un complemento del compilador clang que emite advertencias relacionadas con las prácticas adecuadas de Qt.</p>
+    <p xml:lang="et">Clazy on Clangi kompilaatori plugin, mis väljastab Qt parima praktikaga seonduvaid hoiatusi.</p>
+    <p xml:lang="eu">Clazy Clang konpilatzailearen plugin bat da, Qt-ren gaineko praktika onenen abisuak igortzen dituena.</p>
+    <p xml:lang="fr">Clazy est un module externe Clang émettant des avertissements concernant les bonnes pratiques Qt.</p>
+    <p xml:lang="it">Clazy è un'estensione per il compilatore clang che emette avvisi relativi alle migliori pratiche per Qt</p>
+    <p xml:lang="ko">Clazy는 Qt 권고 사항과 관련된 경고를 출력하는 Clang 컴파일러 플러그인입니다.</p>
+    <p xml:lang="lt">Clang yra clang kompiliatoriaus papildinys, kuris parodo įspėjimus, susijusius su Qt gerąja patirtimi.</p>
+    <p xml:lang="nl">Clazy is een clang-compilerplug-in die waarschuwingen uitstuurt gerelateerd aan de beste praktijken van Qt.</p>
+    <p xml:lang="nn">Clazy er eit kompilatortillegg for Clang som viser åtvaringar knytte til mønsterpraksis for Qt-utvikling.</p>
+    <p xml:lang="pt">O Clazy é um 'plugin' do compilador Clang que emite avisos relacionados com as boas práticas do Qt.</p>
+    <p xml:lang="pt-BR">O Clazy é um plugin do compilador Clang que emite avisos relacionados às melhores práticas do Qt</p>
+    <p xml:lang="sl">Clazy je vtičnik prevajalnika clang, ki oddaja opozorila povezana z najboljšimi praksami Qt.</p>
+    <p xml:lang="sv">Clazy är ett insticksprogram för Clang-kompilatorn som producerar varningar relaterade till bästa praxis för Qt.</p>
+    <p xml:lang="uk">Clazy є додатком до компілятора Clang, який попереджає про порушення правил правильного програмування з використанням Qt.</p>
+    <p xml:lang="x-test">xxClazy is a clang compiler plugin which emits warnings related to Qt best practices.xx</p>
   </description>
   <categories>
 ​    <category>Development</category>
diff -pruN 1.6-2/README.md 1.7-1/README.md
--- 1.6-2/README.md	2019-10-12 08:39:47.000000000 +0000
+++ 1.7-1/README.md	2020-06-28 23:30:42.000000000 +0000
@@ -1,6 +1,4 @@
-*WARNING:* master is the development branch. Please use the v1.6 branch.
-
-clazy v1.6
+clazy v1.7
 ===========
 
 clazy is a compiler plugin which allows clang to understand Qt semantics. You get more than 50 Qt related compiler warnings, ranging from unneeded memory allocations to misusage of API, including fix-its for automatic refactoring.
@@ -43,8 +41,7 @@ Table of contents
 You can get clazy from:
 
 - <https://github.com/KDE/clazy>
-- git@git.kde.org:clazy
-- git://anongit.kde.org/clazy
+- <https://invent.kde.org/sdk/clazy>
 
 # Pre-built binaries
 
@@ -221,12 +218,14 @@ clazy runs all checks from level1 by def
     - [ifndef-define-typo](docs/checks/README-ifndef-define-typo.md)
     - [inefficient-qlist](docs/checks/README-inefficient-qlist.md)
     - [isempty-vs-count](docs/checks/README-isempty-vs-count.md)
+    - [jni-signatures](docs/checks/README-jni-signatures.md)
     - [qhash-with-char-pointer-key](docs/checks/README-qhash-with-char-pointer-key.md)
     - [qproperty-type-mismatch](docs/checks/README-qproperty-type-mismatch.md)
     - [qrequiredresult-candidates](docs/checks/README-qrequiredresult-candidates.md)
     - [qstring-varargs](docs/checks/README-qstring-varargs.md)
     - [qt-keywords](docs/checks/README-qt-keywords.md)    (fix-qt-keywords)
     - [qt4-qstring-from-array](docs/checks/README-qt4-qstring-from-array.md)    (fix-qt4-qstring-from-array)
+    - [qt6-qlatin1string-to-u](docs/checks/README-qt6-qlatin1string-to-u.md)    (fix-qt6-qlatin1string-to-u)
     - [qvariant-template-instantiation](docs/checks/README-qvariant-template-instantiation.md)
     - [raw-environment-function](docs/checks/README-raw-environment-function.md)
     - [reserve-candidates](docs/checks/README-reserve-candidates.md)
@@ -246,6 +245,7 @@ clazy runs all checks from level1 by def
     - [lambda-unique-connection](docs/checks/README-lambda-unique-connection.md)
     - [lowercase-qml-type-name](docs/checks/README-lowercase-qml-type-name.md)
     - [mutable-container-key](docs/checks/README-mutable-container-key.md)
+    - [overloaded-signal](docs/checks/README-overloaded-signal.md)
     - [qcolor-from-literal](docs/checks/README-qcolor-from-literal.md)
     - [qdatetime-utc](docs/checks/README-qdatetime-utc.md)    (fix-qdatetime-utc)
     - [qenums](docs/checks/README-qenums.md)
@@ -253,6 +253,7 @@ clazy runs all checks from level1 by def
     - [qgetenv](docs/checks/README-qgetenv.md)    (fix-qgetenv)
     - [qmap-with-pointer-key](docs/checks/README-qmap-with-pointer-key.md)
     - [qstring-arg](docs/checks/README-qstring-arg.md)
+    - [qstring-comparison-to-implicit-char](docs/checks/README-qstring-comparison-to-implicit-char.md)
     - [qstring-insensitive-allocation](docs/checks/README-qstring-insensitive-allocation.md)
     - [qstring-ref](docs/checks/README-qstring-ref.md)    (fix-missing-qstringref)
     - [qt-macros](docs/checks/README-qt-macros.md)
@@ -477,10 +478,9 @@ and thanks to:
 
 # Contributing patches
 
-New features go to master and bug fixes go to the 1.6 branch.
-The prefered way to contributing is by using KDE's phabricator, see:
-- <https://community.kde.org/Infrastructure/Phabricator>
-- <https://phabricator.kde.org/differential/>
+New features go to master and bug fixes go to the 1.7 branch.
+The prefered way to contributing is by using KDE's GitLab instance,
+see <https://community.kde.org/Infrastructure/GitLab>.
 
 If you rather just create a pull request in https://github.com/KDE/clazy for a drive-by change, it's also fine, but beware that
 the maintainer might forget to check on github and the KDE bot will close the PR. In that case just send a reminder to the maintainer (smartins at kde.org).
diff -pruN 1.6-2/readmes.cmake 1.7-1/readmes.cmake
--- 1.6-2/readmes.cmake	2019-10-12 08:39:47.000000000 +0000
+++ 1.7-1/readmes.cmake	2020-06-28 23:30:42.000000000 +0000
@@ -6,12 +6,14 @@ SET(README_manuallevel_FILES
     ${CMAKE_CURRENT_LIST_DIR}/docs/checks/README-ifndef-define-typo.md
     ${CMAKE_CURRENT_LIST_DIR}/docs/checks/README-inefficient-qlist.md
     ${CMAKE_CURRENT_LIST_DIR}/docs/checks/README-isempty-vs-count.md
+    ${CMAKE_CURRENT_LIST_DIR}/docs/checks/README-jni-signatures.md
     ${CMAKE_CURRENT_LIST_DIR}/docs/checks/README-qhash-with-char-pointer-key.md
     ${CMAKE_CURRENT_LIST_DIR}/docs/checks/README-qproperty-type-mismatch.md
     ${CMAKE_CURRENT_LIST_DIR}/docs/checks/README-qrequiredresult-candidates.md
     ${CMAKE_CURRENT_LIST_DIR}/docs/checks/README-qstring-varargs.md
     ${CMAKE_CURRENT_LIST_DIR}/docs/checks/README-qt-keywords.md
     ${CMAKE_CURRENT_LIST_DIR}/docs/checks/README-qt4-qstring-from-array.md
+    ${CMAKE_CURRENT_LIST_DIR}/docs/checks/README-qt6-qlatin1string-to-u.md
     ${CMAKE_CURRENT_LIST_DIR}/docs/checks/README-qvariant-template-instantiation.md
     ${CMAKE_CURRENT_LIST_DIR}/docs/checks/README-raw-environment-function.md
     ${CMAKE_CURRENT_LIST_DIR}/docs/checks/README-reserve-candidates.md
@@ -32,6 +34,7 @@ SET(README_LEVEL0_FILES
     ${CMAKE_CURRENT_LIST_DIR}/docs/checks/README-lambda-unique-connection.md
     ${CMAKE_CURRENT_LIST_DIR}/docs/checks/README-lowercase-qml-type-name.md
     ${CMAKE_CURRENT_LIST_DIR}/docs/checks/README-mutable-container-key.md
+    ${CMAKE_CURRENT_LIST_DIR}/docs/checks/README-overloaded-signal.md
     ${CMAKE_CURRENT_LIST_DIR}/docs/checks/README-qcolor-from-literal.md
     ${CMAKE_CURRENT_LIST_DIR}/docs/checks/README-qdatetime-utc.md
     ${CMAKE_CURRENT_LIST_DIR}/docs/checks/README-qenums.md
@@ -39,6 +42,7 @@ SET(README_LEVEL0_FILES
     ${CMAKE_CURRENT_LIST_DIR}/docs/checks/README-qgetenv.md
     ${CMAKE_CURRENT_LIST_DIR}/docs/checks/README-qmap-with-pointer-key.md
     ${CMAKE_CURRENT_LIST_DIR}/docs/checks/README-qstring-arg.md
+    ${CMAKE_CURRENT_LIST_DIR}/docs/checks/README-qstring-comparison-to-implicit-char.md
     ${CMAKE_CURRENT_LIST_DIR}/docs/checks/README-qstring-insensitive-allocation.md
     ${CMAKE_CURRENT_LIST_DIR}/docs/checks/README-qstring-ref.md
     ${CMAKE_CURRENT_LIST_DIR}/docs/checks/README-qt-macros.md
diff -pruN 1.6-2/src/checkbase.cpp 1.7-1/src/checkbase.cpp
--- 1.6-2/src/checkbase.cpp	2019-10-12 08:39:47.000000000 +0000
+++ 1.7-1/src/checkbase.cpp	2020-06-28 23:30:42.000000000 +0000
@@ -251,8 +251,9 @@ void CheckBase::reallyEmitWarning(clang:
 {
     FullSourceLoc full(loc, sm());
     auto &engine = m_context->ci.getDiagnostics();
-    auto severity = (engine.getWarningsAsErrors() && !m_context->userDisabledWError()) ? DiagnosticIDs::Error
-                                                                                       : DiagnosticIDs::Warning;
+    auto severity = (m_context->treatAsError(m_name) || (engine.getWarningsAsErrors() && !m_context->userDisabledWError()))
+            ? DiagnosticIDs::Error
+            : DiagnosticIDs::Warning;
     unsigned id = engine.getDiagnosticIDs()->getCustomDiagID(severity, error.c_str());
     DiagnosticBuilder B = engine.Report(full, id);
     for (const FixItHint& fixit : fixits) {
diff -pruN 1.6-2/src/checkmanager.cpp 1.7-1/src/checkmanager.cpp
--- 1.6-2/src/checkmanager.cpp	2019-10-12 08:39:47.000000000 +0000
+++ 1.7-1/src/checkmanager.cpp	2020-06-28 23:30:42.000000000 +0000
@@ -317,3 +317,28 @@ RegisteredCheck::List CheckManager::chec
 
     return result;
 }
+
+vector<string> CheckManager::checksAsErrors() const
+{
+    auto checksAsErrosEnv = getenv("CLAZY_CHECKS_AS_ERRORS");
+
+    if (checksAsErrosEnv) {
+        auto checkNames = clazy::splitString(checksAsErrosEnv, ',');
+        vector<string> result;
+
+        // Check whether all supplied check names are valid
+        for (const string &name : checkNames) {
+            auto it = clazy::find_if(m_registeredChecks, [&name](const RegisteredCheck &check)
+            {
+                return check.name == name;
+            });
+            if (it == m_registeredChecks.end())
+                llvm::errs() << "Invalid check: " << name << '\n';
+            else
+                result.emplace_back(name);
+        }
+        return result;
+    }
+    else
+        return {};
+}
diff -pruN 1.6-2/src/checkmanager.h 1.7-1/src/checkmanager.h
--- 1.6-2/src/checkmanager.h	2019-10-12 08:39:47.000000000 +0000
+++ 1.7-1/src/checkmanager.h	2020-06-28 23:30:42.000000000 +0000
@@ -93,6 +93,7 @@ public:
     static std::mutex &lock() { return m_lock; }
     RegisteredCheck::List availableChecks(CheckLevel maxLevel) const;
     RegisteredCheck::List requestedChecksThroughEnv(std::vector<std::string> &userDisabledChecks) const;
+    std::vector<std::string> checksAsErrors() const;
 
     RegisteredCheck::List::const_iterator checkForName(const RegisteredCheck::List &checks, const std::string &name) const;
     RegisteredCheck::List checksForCommaSeparatedString(const std::string &str) const;
diff -pruN 1.6-2/src/checks/inefficientqlistbase.cpp 1.7-1/src/checks/inefficientqlistbase.cpp
--- 1.6-2/src/checks/inefficientqlistbase.cpp	2019-10-12 08:39:47.000000000 +0000
+++ 1.7-1/src/checks/inefficientqlistbase.cpp	2020-06-28 23:30:42.000000000 +0000
@@ -70,7 +70,7 @@ bool InefficientQListBase::shouldIgnoreV
     }
 
     Stmt *body = fDecl ? fDecl->getBody() : nullptr;
-    if ((m_ignoreMode & IgnoreIsAssignedToInFunction) && Utils::isAssignedTo(body, varDecl)) {
+    if ((m_ignoreMode & IgnoreIsAssignedToInFunction) && Utils::isAssignedFrom(body, varDecl)) {
         return true;
     }
 
diff -pruN 1.6-2/src/checks/level0/connect-non-signal.cpp 1.7-1/src/checks/level0/connect-non-signal.cpp
--- 1.6-2/src/checks/level0/connect-non-signal.cpp	2019-10-12 08:39:47.000000000 +0000
+++ 1.7-1/src/checks/level0/connect-non-signal.cpp	2020-06-28 23:30:42.000000000 +0000
@@ -55,7 +55,7 @@ void ConnectNonSignal::VisitStmt(clang::
 
     CXXMethodDecl *method = clazy::pmfFromConnect(call, /*argIndex=*/ 1);
     if (!method) {
-        emitInternalError(clazy::getLocStart(func), "couldn't find method from pmf connect");
+        emitInternalError(clazy::getLocStart(call), "couldn't find method from pmf connect");
         return;
     }
 
diff -pruN 1.6-2/src/checks/level0/overloaded-signal.cpp 1.7-1/src/checks/level0/overloaded-signal.cpp
--- 1.6-2/src/checks/level0/overloaded-signal.cpp	1970-01-01 00:00:00.000000000 +0000
+++ 1.7-1/src/checks/level0/overloaded-signal.cpp	2020-06-28 23:30:42.000000000 +0000
@@ -0,0 +1,77 @@
+/*
+  This file is part of the clazy static checker.
+
+  Copyright (C) 2019 Sergio Martins <smartins@kde.org>
+
+  This library is free software; you can redistribute it and/or
+  modify it under the terms of the GNU Library General Public
+  License as published by the Free Software Foundation; either
+  version 2 of the License, or (at your option) any later version.
+
+  This library is distributed in the hope that it will be useful,
+  but WITHOUT ANY WARRANTY; without even the implied warranty of
+  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+  Library General Public License for more details.
+
+  You should have received a copy of the GNU Library General Public License
+  along with this library; see the file COPYING.LIB.  If not, write to
+  the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
+  Boston, MA 02110-1301, USA.
+*/
+
+#include "overloaded-signal.h"
+#include "Utils.h"
+#include "HierarchyUtils.h"
+#include "QtUtils.h"
+#include "TypeUtils.h"
+#include "AccessSpecifierManager.h"
+
+#include <ClazyContext.h>
+#include <clang/AST/AST.h>
+
+using namespace clang;
+using namespace std;
+
+
+OverloadedSignal::OverloadedSignal(const std::string &name, ClazyContext *context)
+    : CheckBase(name, context)
+{
+    context->enableAccessSpecifierManager();
+}
+
+void OverloadedSignal::VisitDecl(clang::Decl *decl)
+{
+    AccessSpecifierManager *accessSpecifierManager = m_context->accessSpecifierManager;
+    auto method = dyn_cast<CXXMethodDecl>(decl);
+    if (!accessSpecifierManager || !method)
+        return;
+
+    if (method->isThisDeclarationADefinition() && !method->hasInlineBody())
+        return;
+
+    CXXRecordDecl *record = method->getParent();
+
+    const bool methodIsSignal = accessSpecifierManager->qtAccessSpecifierType(method) == QtAccessSpecifier_Signal;
+    if (!methodIsSignal)
+        return;
+
+
+    const StringRef methodName = clazy::name(method);
+    CXXRecordDecl *p = record; // baseClass starts at record so we check overloaded methods there
+    while (p) {
+        for (auto m : p->methods()) {
+            if (clazy::name(m) == methodName) {
+                if (!clazy::parametersMatch(m, method)) {
+                    if (p == record) {
+                        emitWarning(decl, "signal " + methodName.str() + " is overloaded");
+                        continue; // No point in spitting more warnings for the same signal
+                    } else {
+                        emitWarning(decl, "signal " + methodName.str() + " is overloaded (with " + clazy::getLocStart(p).printToString(sm()) + ")");
+                    }
+                }
+            }
+        }
+
+        p = clazy::getQObjectBaseClass(p);
+    }
+}
diff -pruN 1.6-2/src/checks/level0/overloaded-signal.h 1.7-1/src/checks/level0/overloaded-signal.h
--- 1.6-2/src/checks/level0/overloaded-signal.h	1970-01-01 00:00:00.000000000 +0000
+++ 1.7-1/src/checks/level0/overloaded-signal.h	2020-06-28 23:30:42.000000000 +0000
@@ -0,0 +1,38 @@
+/*
+  This file is part of the clazy static checker.
+
+  Copyright (C) 2019 Sergio Martins <smartins@kde.org>
+
+  This library is free software; you can redistribute it and/or
+  modify it under the terms of the GNU Library General Public
+  License as published by the Free Software Foundation; either
+  version 2 of the License, or (at your option) any later version.
+
+  This library is distributed in the hope that it will be useful,
+  but WITHOUT ANY WARRANTY; without even the implied warranty of
+  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+  Library General Public License for more details.
+
+  You should have received a copy of the GNU Library General Public License
+  along with this library; see the file COPYING.LIB.  If not, write to
+  the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
+  Boston, MA 02110-1301, USA.
+*/
+
+#ifndef CLAZY_OVERLOADED_SIGNAL_H
+#define CLAZY_OVERLOADED_SIGNAL_H
+
+#include "checkbase.h"
+
+
+/**
+ * See README-overloaded-signal.md for more info.
+ */
+class OverloadedSignal : public CheckBase
+{
+public:
+    explicit OverloadedSignal(const std::string &name, ClazyContext *context);
+    void VisitDecl(clang::Decl *) override;
+};
+
+#endif
diff -pruN 1.6-2/src/checks/level0/qstring-arg.cpp 1.7-1/src/checks/level0/qstring-arg.cpp
--- 1.6-2/src/checks/level0/qstring-arg.cpp	2019-10-12 08:39:47.000000000 +0000
+++ 1.7-1/src/checks/level0/qstring-arg.cpp	2020-06-28 23:30:42.000000000 +0000
@@ -25,6 +25,8 @@
 #include "HierarchyUtils.h"
 #include "SourceCompatibilityHelpers.h"
 #include "clazy_stl.h"
+#include "ClazyContext.h"
+#include "PreProcessorVisitor.h"
 
 #include <clang/AST/Decl.h>
 #include <clang/AST/DeclCXX.h>
@@ -48,6 +50,7 @@ QStringArg::QStringArg(const std::string
     : CheckBase(name, context, Option_CanIgnoreIncludes)
 {
     m_filesToIgnore = { "qstring.h" };
+    context->enablePreprocessorVisitor();
 }
 
 static string variableNameFromArg(Expr *arg)
@@ -62,7 +65,7 @@ static string variableNameFromArg(Expr *
     return {};
 }
 
-static CXXMethodDecl* isArgMethod(FunctionDecl *func)
+static CXXMethodDecl* isArgMethod(FunctionDecl *func, const char *className)
 {
     if (!func)
         return nullptr;
@@ -72,7 +75,7 @@ static CXXMethodDecl* isArgMethod(Functi
         return nullptr;
 
     CXXRecordDecl *record = method->getParent();
-    if (!record || clazy::name(record) != "QString")
+    if (!record || clazy::name(record) != className)
         return nullptr;
 
     return method;
@@ -83,7 +86,7 @@ static bool isArgFuncWithOnlyQString(Cal
     if (!callExpr)
         return false;
 
-    CXXMethodDecl *method = isArgMethod(callExpr->getDirectCallee());
+    CXXMethodDecl *method = isArgMethod(callExpr->getDirectCallee(), "QString");
     if (!method)
         return false;
 
@@ -140,6 +143,29 @@ void QStringArg::checkForMultiArgOpportu
     checkMultiArgWarningCase(argCalls);
 }
 
+bool QStringArg::checkQLatin1StringCase(CXXMemberCallExpr *memberCall)
+{
+    PreProcessorVisitor *preProcessorVisitor = m_context->preprocessorVisitor;
+    if (!preProcessorVisitor || preProcessorVisitor->qtVersion() < 51400) {
+        // QLatin1String::arg() was introduced in Qt 5.14
+        return false;
+    }
+
+    if (!isArgMethod(memberCall->getDirectCallee(), "QLatin1String"))
+        return false;
+
+    if (memberCall->getNumArgs() == 0)
+        return false;
+
+    Expr *arg = memberCall->getArg(0);
+    QualType t = arg->getType();
+    if (!t->isIntegerType() || t->isCharType())
+        return false;
+
+    emitWarning(memberCall, "Argument passed to QLatin1String::arg() will be implicitly cast to QChar");
+    return true;
+}
+
 void QStringArg::VisitStmt(clang::Stmt *stmt)
 {
     auto memberCall = dyn_cast<CXXMemberCallExpr>(stmt);
@@ -151,10 +177,13 @@ void QStringArg::VisitStmt(clang::Stmt *
 
     checkForMultiArgOpportunities(memberCall);
 
+    if (checkQLatin1StringCase(memberCall))
+        return;
+
     if (!isOptionSet("fillChar-overloads"))
         return;
 
-    CXXMethodDecl *method = isArgMethod(memberCall->getDirectCallee());
+    CXXMethodDecl *method = isArgMethod(memberCall->getDirectCallee(), "QString");
     if (!method)
         return;
 
diff -pruN 1.6-2/src/checks/level0/qstring-arg.h 1.7-1/src/checks/level0/qstring-arg.h
--- 1.6-2/src/checks/level0/qstring-arg.h	2019-10-12 08:39:47.000000000 +0000
+++ 1.7-1/src/checks/level0/qstring-arg.h	2020-06-28 23:30:42.000000000 +0000
@@ -46,6 +46,7 @@ public:
     void VisitStmt(clang::Stmt *stmt) override;
     void checkForMultiArgOpportunities(clang::CXXMemberCallExpr *memberCall);
 private:
+    bool checkQLatin1StringCase(clang::CXXMemberCallExpr *);
     bool checkMultiArgWarningCase(const std::vector<clang::CallExpr *> &calls);
     std::vector<clang::CallExpr*> m_alreadyProcessedChainedCalls;
 };
diff -pruN 1.6-2/src/checks/level0/qstring-comparison-to-implicit-char.cpp 1.7-1/src/checks/level0/qstring-comparison-to-implicit-char.cpp
--- 1.6-2/src/checks/level0/qstring-comparison-to-implicit-char.cpp	1970-01-01 00:00:00.000000000 +0000
+++ 1.7-1/src/checks/level0/qstring-comparison-to-implicit-char.cpp	2020-06-28 23:30:42.000000000 +0000
@@ -0,0 +1,64 @@
+/*
+  This file is part of the clazy static checker.
+
+  Copyright (C) 2020 Sergio Martins <smartins@kde.org>
+
+  This library is free software; you can redistribute it and/or
+  modify it under the terms of the GNU Library General Public
+  License as published by the Free Software Foundation; either
+  version 2 of the License, or (at your option) any later version.
+
+  This library is distributed in the hope that it will be useful,
+  but WITHOUT ANY WARRANTY; without even the implied warranty of
+  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+  Library General Public License for more details.
+
+  You should have received a copy of the GNU Library General Public License
+  along with this library; see the file COPYING.LIB.  If not, write to
+  the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
+  Boston, MA 02110-1301, USA.
+*/
+
+#include "qstring-comparison-to-implicit-char.h"
+#include "Utils.h"
+#include "HierarchyUtils.h"
+#include "QtUtils.h"
+#include "TypeUtils.h"
+
+#include <clang/AST/AST.h>
+
+using namespace clang;
+using namespace std;
+
+
+QStringComparisonToImplicitChar::QStringComparisonToImplicitChar(const std::string &name, ClazyContext *context)
+    : CheckBase(name, context)
+{
+}
+
+void QStringComparisonToImplicitChar::VisitStmt(clang::Stmt *stmt)
+{
+    auto callExpr = dyn_cast<CXXOperatorCallExpr>(stmt);
+    if (!callExpr || !callExpr->getCalleeDecl() || callExpr->getNumArgs() != 2)
+        return;
+
+    Expr *arg1 = callExpr->getArg(1);
+    IntegerLiteral *il = clazy::getFirstChildOfType2<IntegerLiteral>(arg1);
+    if (!il)
+        return;
+
+    auto functionDecl = dyn_cast<FunctionDecl>(callExpr->getCalleeDecl());
+    if (!functionDecl || functionDecl->getQualifiedNameAsString() != "operator==")
+        return;
+
+    ParmVarDecl *parm1 = functionDecl->getParamDecl(0);
+    if (parm1->getType().getAsString() != "const class QString &")
+        return;
+
+    ParmVarDecl *parm2 = functionDecl->getParamDecl(1);
+    if (parm2->getType().getAsString() != "class QChar")
+        return;
+
+
+    emitWarning(stmt, "QString being compared to implicit QChar");
+}
diff -pruN 1.6-2/src/checks/level0/qstring-comparison-to-implicit-char.h 1.7-1/src/checks/level0/qstring-comparison-to-implicit-char.h
--- 1.6-2/src/checks/level0/qstring-comparison-to-implicit-char.h	1970-01-01 00:00:00.000000000 +0000
+++ 1.7-1/src/checks/level0/qstring-comparison-to-implicit-char.h	2020-06-28 23:30:42.000000000 +0000
@@ -0,0 +1,39 @@
+/*
+  This file is part of the clazy static checker.
+
+  Copyright (C) 2020 Sergio Martins <smartins@kde.org>
+
+  This library is free software; you can redistribute it and/or
+  modify it under the terms of the GNU Library General Public
+  License as published by the Free Software Foundation; either
+  version 2 of the License, or (at your option) any later version.
+
+  This library is distributed in the hope that it will be useful,
+  but WITHOUT ANY WARRANTY; without even the implied warranty of
+  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+  Library General Public License for more details.
+
+  You should have received a copy of the GNU Library General Public License
+  along with this library; see the file COPYING.LIB.  If not, write to
+  the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
+  Boston, MA 02110-1301, USA.
+*/
+
+#ifndef CLAZY_QSTRING_COMPARISON_TO_IMPLICIT_CHAR_H
+#define CLAZY_QSTRING_COMPARISON_TO_IMPLICIT_CHAR_H
+
+#include "checkbase.h"
+
+
+/**
+ * See README-qstring-comparison-to-implicit-char.md for more info.
+ */
+class QStringComparisonToImplicitChar : public CheckBase
+{
+public:
+    explicit QStringComparisonToImplicitChar(const std::string &name, ClazyContext *context);
+    void VisitStmt(clang::Stmt *) override;
+private:
+};
+
+#endif
diff -pruN 1.6-2/src/checks/level0/qstring-ref.cpp 1.7-1/src/checks/level0/qstring-ref.cpp
--- 1.6-2/src/checks/level0/qstring-ref.cpp	2019-10-12 08:39:47.000000000 +0000
+++ 1.7-1/src/checks/level0/qstring-ref.cpp	2020-06-28 23:30:42.000000000 +0000
@@ -117,7 +117,11 @@ static bool containsChild(Stmt *s, Stmt
         return true;
 
     if (auto mte = dyn_cast<MaterializeTemporaryExpr>(s)) {
+#if LLVM_VERSION_MAJOR >= 10
+        return containsChild(mte->getSubExpr(), target);
+#else
         return containsChild(mte->getTemporary(), target);
+#endif
     } else if (auto ice = dyn_cast<ImplicitCastExpr>(s)) {
         return containsChild(ice->getSubExpr(), target);
     } else if (auto bte = dyn_cast<CXXBindTemporaryExpr>(s)) {
diff -pruN 1.6-2/src/checks/level2/old-style-connect.cpp 1.7-1/src/checks/level2/old-style-connect.cpp
--- 1.6-2/src/checks/level2/old-style-connect.cpp	2019-10-12 08:39:47.000000000 +0000
+++ 1.7-1/src/checks/level2/old-style-connect.cpp	2020-06-28 23:30:42.000000000 +0000
@@ -52,8 +52,6 @@
 #include <llvm/Support/Casting.h>
 #include <llvm/Support/raw_ostream.h>
 
-#include <regex>
-
 namespace clang {
 class MacroInfo;
 }  // namespace clang
diff -pruN 1.6-2/src/checks/level2/qstring-allocations.cpp 1.7-1/src/checks/level2/qstring-allocations.cpp
--- 1.6-2/src/checks/level2/qstring-allocations.cpp	2019-10-12 08:39:47.000000000 +0000
+++ 1.7-1/src/checks/level2/qstring-allocations.cpp	2020-06-28 23:30:42.000000000 +0000
@@ -176,14 +176,39 @@ static StringLiteral* stringLiteralForCa
 void QStringAllocations::VisitCtor(Stmt *stm)
 {
     auto ctorExpr = dyn_cast<CXXConstructExpr>(stm);
+    if (!ctorExpr)
+        return;
+
     if (!Utils::containsStringLiteral(ctorExpr, /**allowEmpty=*/ true))
         return;
 
     CXXConstructorDecl *ctorDecl = ctorExpr->getConstructor();
+#if LLVM_VERSION_MAJOR >= 10
+    // With llvm 10, for some reason, the child CXXConstructExpr of QStringList foo = {"foo}; aren't visited :(.
+    // Do it manually.
+    if (clazy::isOfClass(ctorDecl, "QStringList")) {
+        auto p = clazy::getFirstChildOfType2<CXXConstructExpr>(ctorExpr);
+        while (p) {
+            if (clazy::isOfClass(p, "QString")) {
+                VisitCtor(p);
+            }
+            p = clazy::getFirstChildOfType2<CXXConstructExpr>(p);
+        }
+    } else {
+        VisitCtor(ctorExpr);
+    }
+#else
+    VisitCtor(ctorExpr);
+#endif
+}
+
+void QStringAllocations::VisitCtor(CXXConstructExpr *ctorExpr)
+{
+    CXXConstructorDecl *ctorDecl = ctorExpr->getConstructor();
     if (!clazy::isOfClass(ctorDecl, "QString"))
         return;
 
-    if (Utils::insideCTORCall(m_context->parentMap, stm, { "QRegExp", "QIcon" })) {
+    if (Utils::insideCTORCall(m_context->parentMap, ctorExpr, { "QRegExp", "QIcon" })) {
         // https://blogs.kde.org/2015/11/05/qregexp-qstringliteral-crash-exit
         return;
     }
@@ -193,7 +218,7 @@ void QStringAllocations::VisitCtor(Stmt
         if (initializerList != nullptr)
             return; // Nothing to do here, MSVC doesn't like it
 
-        StringLiteral *lt = stringLiteralForCall(stm);
+        StringLiteral *lt = stringLiteralForCall(ctorExpr);
         if (lt && lt->getNumConcatenated() > 1) {
             return; // Nothing to do here, MSVC doesn't like it
         }
@@ -214,7 +239,7 @@ void QStringAllocations::VisitCtor(Stmt
 
     if (isQLatin1String) {
         ConditionalOperator *ternary = nullptr;
-        Latin1Expr qlatin1expr = qlatin1CtorExpr(stm, ternary);
+        Latin1Expr qlatin1expr = qlatin1CtorExpr(ctorExpr, ternary);
         if (!qlatin1expr.isValid()) {
             return;
         }
@@ -233,7 +258,7 @@ void QStringAllocations::VisitCtor(Stmt
             if (!clazy::getLocStart(qlatin1Ctor).isMacroID()) {
                 if (!ternary) {
                     fixits = fixItReplaceWordWithWord(qlatin1Ctor, "QStringLiteral", "QLatin1String");
-                    bool shouldRemoveQString = clazy::getLocStart(qlatin1Ctor).getRawEncoding() != clazy::getLocStart(stm).getRawEncoding() && dyn_cast_or_null<CXXBindTemporaryExpr>(clazy::parent(m_context->parentMap, ctorExpr));
+                    bool shouldRemoveQString = clazy::getLocStart(qlatin1Ctor).getRawEncoding() != clazy::getLocStart(ctorExpr).getRawEncoding() && dyn_cast_or_null<CXXBindTemporaryExpr>(clazy::parent(m_context->parentMap, ctorExpr));
                     if (shouldRemoveQString) {
                         // This is the case of QString(QLatin1String("foo")), which we just fixed to be QString(QStringLiteral("foo)), so now remove QString
                         auto removalFixits = clazy::fixItRemoveToken(&m_astContext, ctorExpr, true);
@@ -251,7 +276,7 @@ void QStringAllocations::VisitCtor(Stmt
             }
         }
 
-        maybeEmitWarning(clazy::getLocStart(stm), msg, fixits);
+        maybeEmitWarning(clazy::getLocStart(ctorExpr), msg, fixits);
     } else {
         vector<FixItHint> fixits;
         if (clazy::hasChildren(ctorExpr)) {
@@ -293,7 +318,7 @@ void QStringAllocations::VisitCtor(Stmt
             }
         }
 
-        maybeEmitWarning(clazy::getLocStart(stm), msg, fixits);
+        maybeEmitWarning(clazy::getLocStart(ctorExpr), msg, fixits);
     }
 }
 
diff -pruN 1.6-2/src/checks/level2/qstring-allocations.h 1.7-1/src/checks/level2/qstring-allocations.h
--- 1.6-2/src/checks/level2/qstring-allocations.h	2019-10-12 08:39:47.000000000 +0000
+++ 1.7-1/src/checks/level2/qstring-allocations.h	2020-06-28 23:30:42.000000000 +0000
@@ -68,6 +68,7 @@ public:
 
 private:
     void VisitCtor(clang::Stmt *);
+    void VisitCtor(clang::CXXConstructExpr *);
     void VisitOperatorCall(clang::Stmt *);
     void VisitFromLatin1OrUtf8(clang::Stmt *);
     void VisitAssignOperatorQLatin1String(clang::Stmt *);
diff -pruN 1.6-2/src/checks/level2/virtual-call-ctor.cpp 1.7-1/src/checks/level2/virtual-call-ctor.cpp
--- 1.6-2/src/checks/level2/virtual-call-ctor.cpp	2019-10-12 08:39:47.000000000 +0000
+++ 1.7-1/src/checks/level2/virtual-call-ctor.cpp	2020-06-28 23:30:42.000000000 +0000
@@ -26,6 +26,7 @@
 #include "HierarchyUtils.h"
 #include "SourceCompatibilityHelpers.h"
 #include "clazy_stl.h"
+#include "ClazyContext.h"
 
 #include <clang/AST/DeclCXX.h>
 #include <clang/AST/DeclBase.h>
@@ -41,6 +42,26 @@ class ClazyContext;
 using namespace std;
 using namespace clang;
 
+namespace clazy {
+void getChildsIgnoreLambda(clang::Stmt *stmt, std::vector<CXXMemberCallExpr*> &result_list, int depth = -1)
+{
+    if (!stmt || dyn_cast<LambdaExpr>(stmt))
+        return;
+
+    auto cexpr = llvm::dyn_cast<CXXMemberCallExpr>(stmt);
+    if (cexpr)
+        result_list.push_back(cexpr);
+
+    if (depth > 0 || depth == -1) {
+        if (depth > 0)
+            --depth;
+        for (auto child : stmt->children()) {
+            getChildsIgnoreLambda(child, result_list, depth);
+        }
+    }
+}
+}
+
 VirtualCallCtor::VirtualCallCtor(const std::string &name, ClazyContext *context)
     : CheckBase(name, context)
 {
@@ -84,7 +105,9 @@ SourceLocation VirtualCallCtor::contains
     processedStmts.push_back(stmt);
 
     std::vector<CXXMemberCallExpr*> memberCalls;
-    clazy::getChilds<CXXMemberCallExpr>(stmt, memberCalls);
+
+    // Ignore lambdas, as they are usually used in connects. Might introduce true-negatives. Possible solution would be to check if the lambda is in a connect, timer, invokeMethod, etc.
+    clazy::getChildsIgnoreLambda(stmt, memberCalls);
 
     for (CXXMemberCallExpr *callExpr : memberCalls) {
         CXXMethodDecl *memberDecl = callExpr->getMethodDecl();
diff -pruN 1.6-2/src/checks/manuallevel/heap-allocated-small-trivial-type.cpp 1.7-1/src/checks/manuallevel/heap-allocated-small-trivial-type.cpp
--- 1.6-2/src/checks/manuallevel/heap-allocated-small-trivial-type.cpp	2019-10-12 08:39:47.000000000 +0000
+++ 1.7-1/src/checks/manuallevel/heap-allocated-small-trivial-type.cpp	2020-06-28 23:30:42.000000000 +0000
@@ -21,9 +21,11 @@
 
 #include "heap-allocated-small-trivial-type.h"
 #include "Utils.h"
+#include "StmtBodyRange.h"
 #include "HierarchyUtils.h"
 #include "QtUtils.h"
 #include "TypeUtils.h"
+#include "ClazyContext.h"
 
 #include <clang/AST/AST.h>
 
@@ -37,15 +39,28 @@ HeapAllocatedSmallTrivialType::HeapAlloc
 {
 }
 
-void HeapAllocatedSmallTrivialType::VisitStmt(clang::Stmt *stmt)
+void HeapAllocatedSmallTrivialType::VisitDecl(clang::Decl *decl)
 {
-    auto newExpr = dyn_cast<CXXNewExpr>(stmt);
+    auto varDecl = dyn_cast<VarDecl>(decl);
+    if (!varDecl)
+        return;
+
+    Expr *init = varDecl->getInit();
+    if (!init)
+        return;
+
+    auto newExpr = dyn_cast<CXXNewExpr>(init);
     if (!newExpr || newExpr->getNumPlacementArgs() > 0) // Placement new, user probably knows what he's doing
         return;
 
     if (newExpr->isArray())
         return;
 
+    DeclContext *context = varDecl->getDeclContext();
+    FunctionDecl *fDecl = context ? dyn_cast<FunctionDecl>(context) : nullptr;
+    if (!fDecl)
+        return;
+
     QualType qualType = newExpr->getType()->getPointeeType();
     if (clazy::isSmallTrivial(m_context, qualType)) {
         if (clazy::contains(qualType.getAsString(), "Private")) {
@@ -53,6 +68,12 @@ void HeapAllocatedSmallTrivialType::Visi
             return;
         }
 
-        emitWarning(stmt, "Don't heap-allocate small trivially copyable/destructible types: " + qualType.getAsString());
+        auto body = fDecl->getBody();
+        if (Utils::isAssignedTo(body, varDecl) ||
+            Utils::isPassedToFunction(StmtBodyRange(body), varDecl, false) ||
+            Utils::isReturned(body, varDecl))
+            return;
+
+        emitWarning(init, "Don't heap-allocate small trivially copyable/destructible types: " + qualType.getAsString());
     }
 }
diff -pruN 1.6-2/src/checks/manuallevel/heap-allocated-small-trivial-type.h 1.7-1/src/checks/manuallevel/heap-allocated-small-trivial-type.h
--- 1.6-2/src/checks/manuallevel/heap-allocated-small-trivial-type.h	2019-10-12 08:39:47.000000000 +0000
+++ 1.7-1/src/checks/manuallevel/heap-allocated-small-trivial-type.h	2020-06-28 23:30:42.000000000 +0000
@@ -32,7 +32,7 @@ class HeapAllocatedSmallTrivialType : pu
 {
 public:
     explicit HeapAllocatedSmallTrivialType(const std::string &name, ClazyContext *context);
-    void VisitStmt(clang::Stmt *) override;
+    void VisitDecl(clang::Decl *decl) override;
 private:
 };
 
diff -pruN 1.6-2/src/checks/manuallevel/jnisignatures.cpp 1.7-1/src/checks/manuallevel/jnisignatures.cpp
--- 1.6-2/src/checks/manuallevel/jnisignatures.cpp	1970-01-01 00:00:00.000000000 +0000
+++ 1.7-1/src/checks/manuallevel/jnisignatures.cpp	2020-06-28 23:30:42.000000000 +0000
@@ -0,0 +1,139 @@
+/*
+    This file is part of the clazy static checker.
+
+    Copyright (C) 2020 Klarälvdalens Datakonsult AB, a KDAB Group company, info@kdab.com
+    Author: Nicolas Fella <nicolas.fella@kdab.com>
+
+    This library is free software; you can redistribute it and/or
+    modify it under the terms of the GNU Library General Public
+    License as published by the Free Software Foundation; either
+    version 2 of the License, or (at your option) any later version.
+
+    This library is distributed in the hope that it will be useful,
+    but WITHOUT ANY WARRANTY; without even the implied warranty of
+    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+    Library General Public License for more details.
+
+    You should have received a copy of the GNU Library General Public License
+    along with this library; see the file COPYING.LIB.  If not, write to
+    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
+    Boston, MA 02110-1301, USA.
+*/
+
+#include "jnisignatures.h"
+#include "MacroUtils.h"
+#include "FunctionUtils.h"
+#include "StringUtils.h"
+#include "SourceCompatibilityHelpers.h"
+#include "clazy_stl.h"
+
+#include <clang/AST/Expr.h>
+#include <clang/AST/Stmt.h>
+#include <clang/AST/Decl.h>
+#include <clang/AST/DeclCXX.h>
+#include <clang/AST/ExprCXX.h>
+#include <clang/AST/OperationKinds.h>
+#include <clang/Basic/LLVM.h>
+#include <clang/Basic/SourceLocation.h>
+#include <clang/Basic/SourceManager.h>
+#include <llvm/ADT/StringRef.h>
+#include <llvm/Support/Casting.h>
+
+#include <vector>
+
+#include <iostream>
+
+class ClazyContext;
+
+using namespace clang;
+using namespace std;
+
+static const regex methodSignatureRegex("\\((\\[?([ZBCSIJFD]|L([a-zA-Z]+\\/)*[a-zA-Z]+;))*\\)\\[?([ZBCSIJFD]|L([a-zA-Z]+\\/)*[a-zA-Z]+;|V)");
+
+static const regex classNameRegex("([a-zA-Z]+\\/)*[a-zA-Z]+");
+
+static const regex methodNameRegex("[a-zA-Z]+");
+
+JniSignatures::JniSignatures(const std::string &name, ClazyContext *context)
+    : CheckBase(name, context, Option_CanIgnoreIncludes)
+{
+}
+
+bool checkSignature(std::string signature, const regex &expr)
+{
+    smatch match;
+    return regex_match(signature, match, expr);
+}
+
+template<typename T>
+void JniSignatures::checkArgAt(T *call, unsigned int index, const regex &expr, const std::string &errorMessage)
+{
+    if (call->getNumArgs() < index + 1)
+        return;
+
+    StringLiteral *stringLiteral = clazy::getFirstChildOfType2<StringLiteral>(call->getArg(index));
+
+    if (!stringLiteral)
+        return;
+
+    if (stringLiteral->getCharByteWidth() != 1)
+        return;
+
+    const std::string signature = stringLiteral->getString().str();
+
+    const bool valid = checkSignature(signature, expr);
+
+    if (!valid) {
+        emitWarning(call, errorMessage + ": '" + signature + "'");
+    }
+}
+
+void JniSignatures::checkFunctionCall(Stmt *stm)
+{
+    auto callExpr = dyn_cast<CallExpr>(stm);
+    if (!callExpr)
+        return;
+    auto funDecl = callExpr->getDirectCallee();
+    if (!funDecl) {
+        return;
+    }
+
+    const std::string qualifiedName = funDecl->getQualifiedNameAsString();
+    if (!clazy::startsWith(qualifiedName, "QAndroidJniObject::")) {
+        return;
+    }
+
+    const std::string name = clazy::name(funDecl);
+
+    if (name == "callObjectMethod" || name == "callMethod") {
+        checkArgAt(callExpr, 0, methodNameRegex, "Invalid method name");
+        checkArgAt(callExpr, 1, methodSignatureRegex, "Invalid method signature");
+    } else if (name == "callStaticObjectMethod" || name == "callStaticMethod") {
+        checkArgAt(callExpr, 0, classNameRegex, "Invalid class name");
+        checkArgAt(callExpr, 1, methodNameRegex, "Invalid method name");
+        checkArgAt(callExpr, 2, methodSignatureRegex, "Invalid method signature");
+    }
+}
+
+void JniSignatures::checkConstructorCall(Stmt *stm)
+{
+    auto constructExpr = dyn_cast<CXXConstructExpr>(stm);
+    if (!constructExpr) {
+        return;
+    }
+    auto funDecl = constructExpr->getConstructor();
+
+    const std::string qualifiedName = funDecl->getQualifiedNameAsString();
+    if (qualifiedName != "QAndroidJniObject::QAndroidJniObject") {
+        return;
+    }
+
+    checkArgAt(constructExpr, 0, classNameRegex, "Invalid class name");
+    checkArgAt(constructExpr, 1, methodSignatureRegex, "Invalid constructor signature");
+}
+
+void JniSignatures::VisitStmt(Stmt *stm)
+{
+    checkConstructorCall(stm);
+    checkFunctionCall(stm);
+}
diff -pruN 1.6-2/src/checks/manuallevel/jnisignatures.h 1.7-1/src/checks/manuallevel/jnisignatures.h
--- 1.6-2/src/checks/manuallevel/jnisignatures.h	1970-01-01 00:00:00.000000000 +0000
+++ 1.7-1/src/checks/manuallevel/jnisignatures.h	2020-06-28 23:30:42.000000000 +0000
@@ -0,0 +1,51 @@
+/*
+    This file is part of the clazy static checker.
+
+    Copyright (C) 2020 Klarälvdalens Datakonsult AB, a KDAB Group company, info@kdab.com
+    Author: Nicolas Fella <nicolas.fella@kdab.com>
+
+    This library is free software; you can redistribute it and/or
+    modify it under the terms of the GNU Library General Public
+    License as published by the Free Software Foundation; either
+    version 2 of the License, or (at your option) any later version.
+
+    This library is distributed in the hope that it will be useful,
+    but WITHOUT ANY WARRANTY; without even the implied warranty of
+    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+    Library General Public License for more details.
+
+    You should have received a copy of the GNU Library General Public License
+    along with this library; see the file COPYING.LIB.  If not, write to
+    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
+    Boston, MA 02110-1301, USA.
+*/
+
+#ifndef JNISIGNATURES_H
+#define JNISIGNATURES_H
+
+#include "checkbase.h"
+
+#include <string>
+
+class ClazyContext;
+namespace clang {
+class Stmt;
+class CXXMemberCallExpr;
+class FunctionDecl;
+}  // namespace clang
+
+class JniSignatures
+    : public CheckBase
+{
+public:
+    JniSignatures(const std::string &name, ClazyContext *context);
+    void VisitStmt(clang::Stmt *) override;
+private:
+    template<typename T>
+    void checkArgAt(T *call, unsigned int index, const regex &expr, const std::string &errorMessage);
+    void checkConstructorCall(clang::Stmt *stm);
+    void checkFunctionCall(clang::Stmt *stm);
+};
+
+#endif
+
diff -pruN 1.6-2/src/checks/manuallevel/qt6-qlatin1string-to-u.cpp 1.7-1/src/checks/manuallevel/qt6-qlatin1string-to-u.cpp
--- 1.6-2/src/checks/manuallevel/qt6-qlatin1string-to-u.cpp	1970-01-01 00:00:00.000000000 +0000
+++ 1.7-1/src/checks/manuallevel/qt6-qlatin1string-to-u.cpp	2020-06-28 23:30:42.000000000 +0000
@@ -0,0 +1,167 @@
+/*
+    This file is part of the clazy static checker.
+
+    Copyright (C) 2020 The Qt Company Ltd.
+    Copyright (C) 2020 Lucie Gerard <lucie.gerard@qt.io>
+
+    This library is free software; you can redistribute it and/or
+    modify it under the terms of the GNU Library General Public
+    License as published by the Free Software Foundation; either
+    version 2 of the License, or (at your option) any later version.
+
+    This library is distributed in the hope that it will be useful,
+    but WITHOUT ANY WARRANTY; without even the implied warranty of
+    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+    Library General Public License for more details.
+
+    You should have received a copy of the GNU Library General Public License
+    along with this library; see the file COPYING.LIB.  If not, write to
+    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
+    Boston, MA 02110-1301, USA.
+*/
+
+#include "qt6-qlatin1string-to-u.h"
+#include "ClazyContext.h"
+#include "Utils.h"
+#include "StringUtils.h"
+#include "FixItUtils.h"
+#include "HierarchyUtils.h"
+#include "SourceCompatibilityHelpers.h"
+#include "clazy_stl.h"
+
+#include <clang/Lex/Lexer.h>
+#include <clang/AST/Decl.h>
+#include <clang/AST/DeclCXX.h>
+#include <clang/AST/Expr.h>
+#include <clang/AST/ExprCXX.h>
+#include <clang/AST/Stmt.h>
+#include <clang/AST/Type.h>
+#include <clang/Basic/Diagnostic.h>
+#include <clang/Basic/LLVM.h>
+#include <clang/Basic/SourceLocation.h>
+#include <llvm/ADT/ArrayRef.h>
+#include <llvm/ADT/StringRef.h>
+#include <llvm/Support/Casting.h>
+
+using namespace clang;
+using namespace std;
+
+Qt6QLatin1StringToU::Qt6QLatin1StringToU(const std::string &name, ClazyContext *context)
+    : CheckBase(name, context, Option_CanIgnoreIncludes)
+{
+    enablePreProcessorCallbacks();
+}
+
+static bool isInterestingParam(ParmVarDecl *param)
+{
+    const string typeStr = param->getType().getAsString();
+    if (typeStr == "const char *") {// We only want const char*
+        return true;
+    }
+
+    return false;
+}
+
+static bool isInterestingCtorCall(CXXConstructorDecl *ctor)
+{
+    if (!ctor || !clazy::isOfClass(ctor, "QLatin1String"))
+        return false;
+
+    for (auto param : Utils::functionParameters(ctor)) {
+        if (isInterestingParam(param))
+            return true;
+        return false;
+    }
+    return false;
+}
+
+void Qt6QLatin1StringToU::VisitStmt(clang::Stmt *stmt)
+{
+    auto ctorExpr = dyn_cast<CXXConstructExpr>(stmt);
+    if (!ctorExpr)
+        return;
+
+    vector<FixItHint> fixits;
+    string message;
+
+    if (ctorExpr) {
+        CXXConstructorDecl *ctorDecl = ctorExpr->getConstructor();
+        if (!isInterestingCtorCall(ctorDecl))
+            return;
+        message = "QLatin1String(const char *) ctor being called";
+        for (auto macro_pos : m_listingMacroExpand) {
+            if (m_sm.isPointWithin(macro_pos, clazy::getLocStart(stmt), clazy::getLocEnd(stmt))) {
+               emitWarning(clazy::getLocStart(stmt), message, fixits);
+               return;
+            }
+        }
+        fixits = fixitReplace(stmt);
+    } else {
+        return;
+    }
+
+    emitWarning(clazy::getLocStart(stmt), message, fixits);
+}
+
+std::vector<FixItHint> Qt6QLatin1StringToU::fixitReplace(clang::Stmt *stmt)
+{   
+    string replacement = "";
+
+    // Iterating over the stmt's children to build the replacement
+    int i = 0;
+    Stmt *current_stm = stmt;
+    for (auto it = current_stm->child_begin() ; it !=current_stm->child_end() ; it++) {
+        Stmt *child = clazy::childAt(current_stm, i);
+        if (!child)
+            break;
+        ConditionalOperator *parent_condOp = dyn_cast<ConditionalOperator>(current_stm);
+
+        ImplicitCastExpr *child_dynCastExp = dyn_cast<ImplicitCastExpr>(child);
+        StringLiteral *child_stringliteral = dyn_cast<StringLiteral>(child);
+        ConditionalOperator *child_condOp = dyn_cast<ConditionalOperator>(child);
+        CXXBoolLiteralExpr *child_boolLitExp = dyn_cast<CXXBoolLiteralExpr>(child);
+        DeclRefExpr *child_declRefExp = dyn_cast<DeclRefExpr>(child);
+
+         if (child_dynCastExp || child_condOp) {// skipping those.
+            current_stm = child;
+            i = 0;
+        } else if (child_stringliteral) {
+            replacement += "u\"";
+            replacement += child_stringliteral->getString();
+            replacement += "\"";
+            if (parent_condOp && i == 1) // the first string is the second child of the ConditionalOperator.
+                replacement += " : ";
+            i++;
+        } else if (child_boolLitExp) {
+            replacement = child_boolLitExp->getValue() ? "true" : "false";
+            if (parent_condOp)
+                    replacement += " ? ";
+            i++;
+        } else if (child_declRefExp) { // not replacing those cases.
+             // would have to check that the ancestor is a QString, and that the type is something accepted by
+             // the QString constructor.
+             // The NameInfo would then be the replacement.
+            return {};
+        } else {
+            if (it == current_stm->child_end()) {
+                current_stm = child;
+                i = 0;
+            } else {
+                i++;
+            }
+        }
+    }
+
+    if (replacement.size() < 3)
+        return {};
+
+    vector<FixItHint> fixits;
+    fixits.push_back(FixItHint::CreateReplacement(stmt->getSourceRange(), replacement));
+    return fixits;
+}
+
+void Qt6QLatin1StringToU::VisitMacroExpands(const clang::Token &MacroNameTok, const clang::SourceRange &range, const MacroInfo *)
+{
+    m_listingMacroExpand.push_back(range.getBegin());
+    return;
+}
diff -pruN 1.6-2/src/checks/manuallevel/qt6-qlatin1string-to-u.h 1.7-1/src/checks/manuallevel/qt6-qlatin1string-to-u.h
--- 1.6-2/src/checks/manuallevel/qt6-qlatin1string-to-u.h	1970-01-01 00:00:00.000000000 +0000
+++ 1.7-1/src/checks/manuallevel/qt6-qlatin1string-to-u.h	2020-06-28 23:30:42.000000000 +0000
@@ -0,0 +1,63 @@
+/*
+    This file is part of the clazy static checker.
+
+    Copyright (C) 2020 The Qt Company Ltd.
+    Copyright (C) 2020 Lucie Gerard <lucie.gerard@qt.io>
+
+    This library is free software; you can redistribute it and/or
+    modify it under the terms of the GNU Library General Public
+    License as published by the Free Software Foundation; either
+    version 2 of the License, or (at your option) any later version.
+
+    This library is distributed in the hope that it will be useful,
+    but WITHOUT ANY WARRANTY; without even the implied warranty of
+    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+    Library General Public License for more details.
+
+    You should have received a copy of the GNU Library General Public License
+    along with this library; see the file COPYING.LIB.  If not, write to
+    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
+    Boston, MA 02110-1301, USA.
+*/
+
+#ifndef CLAZY_QT6_QLATINSTRING_TO_U_H
+#define CLAZY_QT6_QLATINSTRING_TO_U_H
+
+#include "checkbase.h"
+
+#include <vector>
+#include <string>
+
+class ClazyContext;
+
+namespace clang {
+class Stmt;
+class FixItHint;
+class CXXConstructExpr;
+class CXXOperatorCallExpr;
+class Expr;
+class CXXMemberCallExpr;
+
+class CXXFunctionalCastExpr;
+}
+
+/**
+ * Replaces QLatin1String(char*) calls with u(char*).
+ *
+ * Run only in Qt 6 code.
+ */
+class Qt6QLatin1StringToU
+    : public CheckBase
+{
+public:
+    explicit Qt6QLatin1StringToU(const std::string &name, ClazyContext *context);
+    void VisitStmt(clang::Stmt *stmt) override;
+    void VisitMacroExpands(const clang::Token &MacroNameTok,
+                           const clang::SourceRange &range, const clang::MacroInfo *minfo = nullptr) override;
+private:
+    std::vector<clang::SourceLocation> m_listingMacroExpand;
+    std::vector<clang::FixItHint> fixitReplace(clang::Stmt *stmt);
+
+};
+
+#endif
diff -pruN 1.6-2/src/Checks.h 1.7-1/src/Checks.h
--- 1.6-2/src/Checks.h	2019-10-12 08:39:47.000000000 +0000
+++ 1.7-1/src/Checks.h	2020-06-28 23:30:42.000000000 +0000
@@ -34,12 +34,14 @@
 #include "checks/manuallevel/ifndef-define-typo.h"
 #include "checks/manuallevel/inefficient-qlist.h"
 #include "checks/manuallevel/isempty-vs-count.h"
+#include "checks/manuallevel/jnisignatures.h"
 #include "checks/manuallevel/qhash-with-char-pointer-key.h"
 #include "checks/manuallevel/qproperty-type-mismatch.h"
 #include "checks/manuallevel/qrequiredresult-candidates.h"
 #include "checks/manuallevel/qstring-varargs.h"
 #include "checks/manuallevel/qt-keywords.h"
 #include "checks/manuallevel/qt4-qstring-from-array.h"
+#include "checks/manuallevel/qt6-qlatin1string-to-u.h"
 #include "checks/manuallevel/qvariant-template-instantiation.h"
 #include "checks/manuallevel/raw-environment-function.h"
 #include "checks/manuallevel/reserve-candidates.h"
@@ -57,6 +59,7 @@
 #include "checks/level0/lambda-unique-connection.h"
 #include "checks/level0/lowercase-qml-type-name.h"
 #include "checks/level0/mutable-container-key.h"
+#include "checks/level0/overloaded-signal.h"
 #include "checks/level0/qcolor-from-literal.h"
 #include "checks/level0/qdatetime-utc.h"
 #include "checks/level0/qenums.h"
@@ -64,6 +67,7 @@
 #include "checks/level0/qgetenv.h"
 #include "checks/level0/qmap-with-pointer-key.h"
 #include "checks/level0/qstring-arg.h"
+#include "checks/level0/qstring-comparison-to-implicit-char.h"
 #include "checks/level0/qstring-insensitive-allocation.h"
 #include "checks/level0/qstring-ref.h"
 #include "checks/level0/qt-macros.h"
@@ -123,10 +127,11 @@ void CheckManager::registerChecks()
     registerCheck(check<AssertWithSideEffects>("assert-with-side-effects", ManualCheckLevel,  RegisteredCheck::Option_VisitsStmts));
     registerCheck(check<ContainerInsideLoop>("container-inside-loop", ManualCheckLevel,  RegisteredCheck::Option_VisitsStmts));
     registerCheck(check<DetachingMember>("detaching-member", ManualCheckLevel,  RegisteredCheck::Option_VisitsStmts));
-    registerCheck(check<HeapAllocatedSmallTrivialType>("heap-allocated-small-trivial-type", ManualCheckLevel,  RegisteredCheck::Option_VisitsStmts));
+    registerCheck(check<HeapAllocatedSmallTrivialType>("heap-allocated-small-trivial-type", ManualCheckLevel,  RegisteredCheck::Option_VisitsDecls));
     registerCheck(check<IfndefDefineTypo>("ifndef-define-typo", ManualCheckLevel, RegisteredCheck::Option_None));
     registerCheck(check<InefficientQList>("inefficient-qlist", ManualCheckLevel,  RegisteredCheck::Option_VisitsDecls));
     registerCheck(check<IsEmptyVSCount>("isempty-vs-count", ManualCheckLevel,  RegisteredCheck::Option_VisitsStmts));
+    registerCheck(check<JniSignatures>("jni-signatures", ManualCheckLevel,  RegisteredCheck::Option_VisitsStmts));
     registerCheck(check<QHashWithCharPointerKey>("qhash-with-char-pointer-key", ManualCheckLevel,  RegisteredCheck::Option_VisitsDecls));
     registerCheck(check<QPropertyTypeMismatch>("qproperty-type-mismatch", ManualCheckLevel,  RegisteredCheck::Option_VisitsDecls));
     registerCheck(check<QRequiredResultCandidates>("qrequiredresult-candidates", ManualCheckLevel,  RegisteredCheck::Option_VisitsDecls));
@@ -135,6 +140,8 @@ void CheckManager::registerChecks()
     registerFixIt(1, "fix-qt-keywords", "qt-keywords");
     registerCheck(check<Qt4QStringFromArray>("qt4-qstring-from-array", ManualCheckLevel,  RegisteredCheck::Option_VisitsStmts));
     registerFixIt(1, "fix-qt4-qstring-from-array", "qt4-qstring-from-array");
+    registerCheck(check<Qt6QLatin1StringToU>("qt6-qlatin1string-to-u", ManualCheckLevel,  RegisteredCheck::Option_VisitsStmts));
+    registerFixIt(1, "fix-qt6-qlatin1string-to-u", "qt6-qlatin1string-to-u");
     registerCheck(check<QVariantTemplateInstantiation>("qvariant-template-instantiation", ManualCheckLevel,  RegisteredCheck::Option_VisitsStmts));
     registerCheck(check<RawEnvironmentFunction>("raw-environment-function", ManualCheckLevel,  RegisteredCheck::Option_VisitsStmts));
     registerCheck(check<ReserveCandidates>("reserve-candidates", ManualCheckLevel,  RegisteredCheck::Option_VisitsStmts));
@@ -152,6 +159,7 @@ void CheckManager::registerChecks()
     registerCheck(check<LambdaUniqueConnection>("lambda-unique-connection", CheckLevel0,  RegisteredCheck::Option_VisitsStmts));
     registerCheck(check<LowercaseQMlTypeName>("lowercase-qml-type-name", CheckLevel0,  RegisteredCheck::Option_VisitsStmts));
     registerCheck(check<MutableContainerKey>("mutable-container-key", CheckLevel0,  RegisteredCheck::Option_VisitsDecls));
+    registerCheck(check<OverloadedSignal>("overloaded-signal", CheckLevel0,  RegisteredCheck::Option_VisitsDecls));
 #ifndef CLAZY_DISABLE_AST_MATCHERS
     registerCheck(check<QColorFromLiteral>("qcolor-from-literal", CheckLevel0,  RegisteredCheck::Option_VisitsStmts));
 #endif
@@ -163,6 +171,7 @@ void CheckManager::registerChecks()
     registerFixIt(1, "fix-qgetenv", "qgetenv");
     registerCheck(check<QMapWithPointerKey>("qmap-with-pointer-key", CheckLevel0,  RegisteredCheck::Option_VisitsDecls));
     registerCheck(check<QStringArg>("qstring-arg", CheckLevel0,  RegisteredCheck::Option_VisitsStmts));
+    registerCheck(check<QStringComparisonToImplicitChar>("qstring-comparison-to-implicit-char", CheckLevel0,  RegisteredCheck::Option_VisitsStmts));
     registerCheck(check<QStringInsensitiveAllocation>("qstring-insensitive-allocation", CheckLevel0,  RegisteredCheck::Option_VisitsStmts));
     registerCheck(check<StringRefCandidates>("qstring-ref", CheckLevel0,  RegisteredCheck::Option_VisitsStmts));
     registerFixIt(1, "fix-missing-qstringref", "qstring-ref");
@@ -208,10 +217,8 @@ void CheckManager::registerChecks()
     registerCheck(check<ImplicitCasts>("implicit-casts", CheckLevel2,  RegisteredCheck::Option_VisitsStmts));
     registerCheck(check<MissingQObjectMacro>("missing-qobject-macro", CheckLevel2,  RegisteredCheck::Option_VisitsDecls));
     registerCheck(check<MissingTypeInfo>("missing-typeinfo", CheckLevel2,  RegisteredCheck::Option_VisitsDecls));
-#ifndef NO_STD_REGEX
     registerCheck(check<OldStyleConnect>("old-style-connect", CheckLevel2, RegisteredCheck::Option_Qt4Incompatible | RegisteredCheck::Option_VisitsStmts));
     registerFixIt(1, "fix-old-style-connect", "old-style-connect");
-#endif
     registerCheck(check<QStringAllocations>("qstring-allocations", CheckLevel2, RegisteredCheck::Option_Qt4Incompatible | RegisteredCheck::Option_VisitsStmts));
     registerFixIt(1, "fix-qlatin1string-allocations", "qstring-allocations");
     registerFixIt(2, "fix-fromLatin1_fromUtf8-allocations", "qstring-allocations");
diff -pruN 1.6-2/src/ClazyContext.cpp 1.7-1/src/ClazyContext.cpp
--- 1.6-2/src/ClazyContext.cpp	2019-10-12 08:39:47.000000000 +0000
+++ 1.7-1/src/ClazyContext.cpp	2020-06-28 23:30:42.000000000 +0000
@@ -20,6 +20,7 @@
 */
 
 #include "AccessSpecifierManager.h"
+#include "checkmanager.h"
 #include "ClazyContext.h"
 #include "FixItExporter.h"
 #include "PreProcessorVisitor.h"
@@ -44,6 +45,7 @@ ClazyContext::ClazyContext(const clang::
     , astContext(ci.getASTContext())
     , sm(ci.getSourceManager())
     , m_noWerror(getenv("CLAZY_NO_WERROR") != nullptr) // Allows user to make clazy ignore -Werror
+    , m_checksPromotedToErrors(CheckManager::instance()->checksAsErrors())
     , options(opts)
     , extraOptions(clazy::splitString(getenv("CLAZY_EXTRA_OPTIONS"), ','))
     , m_translationUnitPaths(translationUnitPaths)
diff -pruN 1.6-2/src/ClazyContext.h 1.7-1/src/ClazyContext.h
--- 1.6-2/src/ClazyContext.h	2019-10-12 08:39:47.000000000 +0000
+++ 1.7-1/src/ClazyContext.h	2020-06-28 23:30:42.000000000 +0000
@@ -156,6 +156,11 @@ public:
         return sm.isInFileID(loc, sm.getMainFileID());
     }
 
+    bool treatAsError(const std::string &checkName) const
+    {
+        return clazy::contains(m_checksPromotedToErrors, checkName);
+    }
+
     /**
      * We only enable it if a check needs it, for performance reasons
      */
@@ -174,6 +179,7 @@ public:
     PreProcessorVisitor *preprocessorVisitor = nullptr;
     SuppressionManager suppressionManager;
     const bool m_noWerror;
+    std::vector<std::string> m_checksPromotedToErrors;
     bool m_visitsAllTypeDefs = false;
     clang::ParentMap *parentMap = nullptr;
     const ClazyOptions options;
diff -pruN 1.6-2/src/ClazyStandaloneMain.cpp 1.7-1/src/ClazyStandaloneMain.cpp
--- 1.6-2/src/ClazyStandaloneMain.cpp	2019-10-12 08:39:47.000000000 +0000
+++ 1.7-1/src/ClazyStandaloneMain.cpp	2020-06-28 23:30:42.000000000 +0000
@@ -93,7 +93,11 @@ public:
     {
     }
 
+#if LLVM_VERSION_MAJOR >= 10
+    std::unique_ptr<FrontendAction> create() override
+#else
     FrontendAction *create() override
+#endif
     {
         ClazyContext::ClazyOptions options = ClazyContext::ClazyOption_None;
 
@@ -116,28 +120,22 @@ public:
             options |= ClazyContext::ClazyOption_IgnoreIncludedFiles;
 
         // TODO: We need to agregate the fixes with previous run
+#if LLVM_VERSION_MAJOR >= 10
+        return std::make_unique<ClazyStandaloneASTAction>(s_checks.getValue(), s_headerFilter.getValue(),
+                                                          s_ignoreDirs.getValue(), s_exportFixes.getValue(),
+                                                          m_paths, options);
+#else
         return new ClazyStandaloneASTAction(s_checks.getValue(), s_headerFilter.getValue(),
                                             s_ignoreDirs.getValue(), s_exportFixes.getValue(),
                                             m_paths, options);
+#endif
     }
     std::vector<std::string> m_paths;
 };
 
 int main(int argc, const char **argv)
 {
-#if LLVM_VERSION_MAJOR >= 9
-    /* HACK: cl::ZeroOrMore makes clazy-standalone stop working for some reason (with llvm-9).
-     * optionsParser.getSourcePathList() returns 0, even with a command as simple as:
-     *     clang-standalone main.cpp
-     * The exact same command line works in clang-tidy, which has the same CommonOptionsParser code.
-     * Commented for now to figure if it's a compiler bug on my archlinux.
-     */
-    auto numOccurrencesFlag = cl::OneOrMore;
-#else
-    auto numOccurrencesFlag = cl::ZeroOrMore;
-#endif
-
-    CommonOptionsParser optionsParser(argc, argv, s_clazyCategory, numOccurrencesFlag);
+    CommonOptionsParser optionsParser(argc, argv, s_clazyCategory, cl::ZeroOrMore);
     // llvm::errs() << optionsParser.getSourcePathList().size() << "\n";
 
     if (s_supportedChecks.getValue()) {
diff -pruN 1.6-2/src/FixItExporter.cpp 1.7-1/src/FixItExporter.cpp
--- 1.6-2/src/FixItExporter.cpp	2019-10-12 08:39:47.000000000 +0000
+++ 1.7-1/src/FixItExporter.cpp	2020-06-28 23:30:42.000000000 +0000
@@ -189,10 +189,13 @@ void FixItExporter::HandleDiagnostic(Dia
 
 void FixItExporter::Export()
 {
-    std::error_code EC;
-    llvm::raw_fd_ostream OS(exportFixes, EC, llvm::sys::fs::F_None);
-    llvm::yaml::Output YAML(OS);
-    YAML << getTuDiag();
+    auto tuDiag = getTuDiag();
+    if (!tuDiag.Diagnostics.empty()) {
+        std::error_code EC;
+        llvm::raw_fd_ostream OS(exportFixes, EC, llvm::sys::fs::F_None);
+        llvm::yaml::Output YAML(OS);
+        YAML << getTuDiag();
+    }
 }
 
 void FixItExporter::Diag(SourceLocation Loc, unsigned DiagID)
diff -pruN 1.6-2/src/QtUtils.cpp 1.7-1/src/QtUtils.cpp
--- 1.6-2/src/QtUtils.cpp	2019-10-12 08:39:47.000000000 +0000
+++ 1.7-1/src/QtUtils.cpp	2020-06-28 23:30:42.000000000 +0000
@@ -305,6 +305,8 @@ CXXMethodDecl *clazy::pmfFromUnary(Expr
         // QOverload case, go deeper one level to get to the UnaryOperator
         if (callexpr->getNumArgs() == 1)
             return pmfFromUnary(callexpr->getArg(0));
+    } else if (auto impl = dyn_cast<ImplicitCastExpr>(expr)) {
+        return pmfFromUnary(impl->getSubExpr());
     }
 
     return nullptr;
diff -pruN 1.6-2/src/SourceCompatibilityHelpers.h 1.7-1/src/SourceCompatibilityHelpers.h
--- 1.6-2/src/SourceCompatibilityHelpers.h	2019-10-12 08:39:47.000000000 +0000
+++ 1.7-1/src/SourceCompatibilityHelpers.h	2020-06-28 23:30:42.000000000 +0000
@@ -31,6 +31,17 @@
 #include <clang/Frontend/FrontendDiagnostic.h>
 #include <clang/Tooling/Core/Diagnostic.h>
 
+#if defined(CLAZY_USES_BOOST_REGEX)
+# define BOOST_NO_EXCEPTIONS
+# include <boost/throw_exception.hpp>
+inline void boost::throw_exception(std::exception const &){}
+# include <boost/regex.hpp>
+using namespace boost;
+#else
+# include <regex>
+using namespace std;
+#endif
+
 namespace clazy {
 
 template <typename T>
diff -pruN 1.6-2/src/SuppressionManager.cpp 1.7-1/src/SuppressionManager.cpp
--- 1.6-2/src/SuppressionManager.cpp	2019-10-12 08:39:47.000000000 +0000
+++ 1.7-1/src/SuppressionManager.cpp	2020-06-28 23:30:42.000000000 +0000
@@ -20,6 +20,7 @@
 */
 
 #include "SuppressionManager.h"
+#include "SourceCompatibilityHelpers.h"
 #include "clazy_stl.h"
 
 #include <clang/Basic/SourceManager.h>
@@ -32,10 +33,6 @@
 
 #include <vector>
 
-#ifndef NO_STD_REGEX
-# include <regex>
-#endif
-
 using namespace clang;
 using namespace std;
 
@@ -46,10 +43,6 @@ SuppressionManager::SuppressionManager()
 bool SuppressionManager::isSuppressed(const std::string &checkName, clang::SourceLocation loc,
                                       const clang::SourceManager &sm, const clang::LangOptions &lo) const
 {
-#ifdef NO_STD_REGEX
-    return false;
-#endif
-
     if (loc.isMacroID())
         loc = sm.getExpansionLoc(loc);
 
@@ -86,7 +79,6 @@ bool SuppressionManager::isSuppressed(co
 
 void SuppressionManager::parseFile(FileID id, const SourceManager &sm, const clang::LangOptions &lo) const
 {
-#ifndef NO_STD_REGEX
     const unsigned hash = id.getHashValue();
     auto it = m_processedFileIDs.insert({hash, Suppressions()}).first;
     Suppressions &suppressions = (*it).second;
@@ -120,7 +112,6 @@ void SuppressionManager::parseFile(FileI
                 suppressions.checksToSkip.insert(checks.cbegin(), checks.cend());
             }
 
-
             const int lineNumber = sm.getSpellingLineNumber(token.getLocation());
             if (lineNumber < 0) {
                 llvm::errs() << "SuppressionManager::parseFile: Invalid line number " << lineNumber << "\n";
@@ -137,5 +128,4 @@ void SuppressionManager::parseFile(FileI
             }
         }
     }
-#endif
 }
diff -pruN 1.6-2/src/Utils.cpp 1.7-1/src/Utils.cpp
--- 1.6-2/src/Utils.cpp	2019-10-12 08:39:47.000000000 +0000
+++ 1.7-1/src/Utils.cpp	2020-06-28 23:30:42.000000000 +0000
@@ -405,10 +405,54 @@ bool Utils::addressIsTaken(const clang::
     });
 }
 
+bool Utils::isReturned(Stmt *body, const VarDecl *varDecl)
+{
+    if (!body)
+        return false;
+
+    std::vector<ReturnStmt*> returns;
+    clazy::getChilds<ReturnStmt>(body, returns);
+    for (ReturnStmt *returnStmt : returns) {
+        Expr* retValue = returnStmt->getRetValue();
+        if (!retValue)
+            continue;
+        auto declRef = clazy::unpeal<DeclRefExpr>(retValue, clazy::IgnoreImplicitCasts);
+        if (!declRef)
+            continue;
+        if (declRef->getDecl() == varDecl)
+            return true;
+    }
+
+    return false;
+}
+
 bool Utils::isAssignedTo(Stmt *body, const VarDecl *varDecl)
 {
     if (!body)
         return false;
+
+    std::vector<BinaryOperator*> operatorCalls;
+    clazy::getChilds<BinaryOperator>(body, operatorCalls);
+    for (BinaryOperator *binaryOperator : operatorCalls) {
+        if (binaryOperator->getOpcode() != clang::BO_Assign)
+            continue;
+
+        Expr *rhs = binaryOperator->getRHS();
+        auto declRef = clazy::unpeal<DeclRefExpr>(rhs, clazy::IgnoreImplicitCasts);
+        if (!declRef)
+            continue;
+
+        if (declRef->getDecl() == varDecl)
+            return true;
+    }
+
+    return false;
+}
+
+bool Utils::isAssignedFrom(Stmt *body, const VarDecl *varDecl)
+{
+    if (!body)
+        return false;
 
     std::vector<CXXOperatorCallExpr*> operatorCalls;
     clazy::getChilds<CXXOperatorCallExpr>(body, operatorCalls);
diff -pruN 1.6-2/src/Utils.h 1.7-1/src/Utils.h
--- 1.6-2/src/Utils.h	2019-10-12 08:39:47.000000000 +0000
+++ 1.7-1/src/Utils.h	2020-06-28 23:30:42.000000000 +0000
@@ -122,8 +122,15 @@ bool containsNonConstMemberCall(clang::P
 
 // Returns true if there's an assignment to varDecl in body
 // Example: our_var = something_else
+bool isAssignedFrom(clang::Stmt *body, const clang::VarDecl *varDecl);
+
+// Returns true if varDecl is assigned to something
+// Example: something_else = our_var
 bool isAssignedTo(clang::Stmt *body, const clang::VarDecl *varDecl);
 
+// Returns whether the variable is returned in body
+bool isReturned(clang::Stmt *body, const clang::VarDecl *varDecl);
+
 // Returns true if a body of statements contains a function call that takes our variable (varDecl)
 // By ref or pointer
 bool isPassedToFunction(const StmtBodyRange &bodyRange, const clang::VarDecl *varDecl,
diff -pruN 1.6-2/tests/clazy/test_requested_checks.sh 1.7-1/tests/clazy/test_requested_checks.sh
--- 1.6-2/tests/clazy/test_requested_checks.sh	2019-10-12 08:39:47.000000000 +0000
+++ 1.7-1/tests/clazy/test_requested_checks.sh	2020-06-28 23:30:42.000000000 +0000
@@ -1,5 +1,10 @@
 unset CLAZY_CHECKS
-CLAZY_COMMAND="clazy -c -o /dev/null -xc++ -Xclang -plugin-arg-clazy -Xclang print-requested-checks "
+
+if [ -z "${CLAZY_CXX}" ]; then
+    CLAZY_CXX=clazy
+fi
+
+CLAZY_COMMAND="${CLAZY_CXX} -c -o /dev/null -xc++ -Xclang -plugin-arg-clazy -Xclang print-requested-checks "
 CLAZY_COMMAND_STDIN=$CLAZY_COMMAND"-"
 
 # Test without checks:
diff -pruN 1.6-2/tests/docker/conf.json 1.7-1/tests/docker/conf.json
--- 1.6-2/tests/docker/conf.json	2019-10-12 08:39:47.000000000 +0000
+++ 1.7-1/tests/docker/conf.json	2020-06-28 23:30:42.000000000 +0000
@@ -19,6 +19,12 @@
             "comment" : "llvm-8;Qt-5.9.5"
         },
         {
+            "name" : "ubuntu-19.10",
+            "url" : "iamsergio/clazy-ubuntu-19.10-32bit",
+            "llvm_root" : "/usr/lib/llvm-9",
+            "comment" : "llvm-9;Qt-5.12.4;32bit"
+        },
+        {
             "name" : "debian-unstable",
             "url" : "iamsergio/clazy-debian-unstable",
             "llvm_root" : "/usr/lib/llvm-9",
diff -pruN 1.6-2/tests/docker/images/clazy-ubuntu-19.10-32bit/Dockerfile 1.7-1/tests/docker/images/clazy-ubuntu-19.10-32bit/Dockerfile
--- 1.6-2/tests/docker/images/clazy-ubuntu-19.10-32bit/Dockerfile	1970-01-01 00:00:00.000000000 +0000
+++ 1.7-1/tests/docker/images/clazy-ubuntu-19.10-32bit/Dockerfile	2020-06-28 23:30:42.000000000 +0000
@@ -0,0 +1,12 @@
+# This Dockerfile creates the container for testing on Ubuntu
+# You can run, for example: clazy/tests/docker/test_docker.py -b 1.6 , which will run the tests in all containers
+# Or explicitly: docker run -i -t iamsergio/clazy-ubuntu-19.10-32bit sh /root/clazy/tests/docker/build-clazy.sh 1.6 -j12 none /usr/lib/llvm-9
+
+FROM i386/ubuntu:19.10
+MAINTAINER Sergio Martins (sergio.martins@kdab.com)
+
+RUN apt-get update
+RUN apt install -y g++ cmake clang-9 clang-tools-9 libclang-9-dev libclang-9-dev git-core python3 ninja-build qtbase5-dev qtdeclarative5-dev
+
+WORKDIR /root
+RUN git clone https://github.com/KDE/clazy.git
diff -pruN 1.6-2/tests/heap-allocated-small-trivial-type/main.cpp 1.7-1/tests/heap-allocated-small-trivial-type/main.cpp
--- 1.6-2/tests/heap-allocated-small-trivial-type/main.cpp	2019-10-12 08:39:47.000000000 +0000
+++ 1.7-1/tests/heap-allocated-small-trivial-type/main.cpp	2020-06-28 23:30:42.000000000 +0000
@@ -33,5 +33,39 @@ void test()
 
     auto e = new(0) SmallTrivial;
     auto f = new SmallTrivial[100];
+}
+
+class MyClass
+{
+    void myMethod()
+    {
+        auto a = new SmallTrivial(); // OK
+        m_smallTrivial = a;
+        m_smallTrivial = new SmallTrivial(); // OK
+    }
+
+    SmallTrivial *m_smallTrivial = nullptr;
+};
+
+void receivesSmallTrivial(SmallTrivial *)
+{
+}
+
+
+SmallTrivial* test2()
+{
+    return new SmallTrivial(); // OK
+}
+
+SmallTrivial* test3()
+{
+    auto a = new SmallTrivial(); // OK
+    receivesSmallTrivial(a);
+    return a;
+}
 
+SmallTrivial* test4()
+{
+    auto a = new SmallTrivial(); // OK
+    return a;
 }
diff -pruN 1.6-2/tests/inefficient-qlist/main.cpp.expected.x86 1.7-1/tests/inefficient-qlist/main.cpp.expected.x86
--- 1.6-2/tests/inefficient-qlist/main.cpp.expected.x86	1970-01-01 00:00:00.000000000 +0000
+++ 1.7-1/tests/inefficient-qlist/main.cpp.expected.x86	2020-06-28 23:30:42.000000000 +0000
@@ -0,0 +1,4 @@
+inefficient-qlist/main.cpp:24:5: warning: Use QVector instead of QList for type with size 9 bytes [-Wclazy-inefficient-qlist]
+inefficient-qlist/main.cpp:38:11: warning: Use QVector instead of QList for type with size 9 bytes [-Wclazy-inefficient-qlist]
+inefficient-qlist/main.cpp:40:5: warning: Use QVector instead of QList for type with size 9 bytes [-Wclazy-inefficient-qlist]
+inefficient-qlist/main.cpp:53:5: warning: Use QVector instead of QList for type with size 12 bytes [-Wclazy-inefficient-qlist]
diff -pruN 1.6-2/tests/jni-signatures/config.json 1.7-1/tests/jni-signatures/config.json
--- 1.6-2/tests/jni-signatures/config.json	1970-01-01 00:00:00.000000000 +0000
+++ 1.7-1/tests/jni-signatures/config.json	2020-06-28 23:30:42.000000000 +0000
@@ -0,0 +1,8 @@
+{
+    "tests" : [
+        {
+            "filename" : "main.cpp"
+        }
+    ]
+}
+
diff -pruN 1.6-2/tests/jni-signatures/main.cpp 1.7-1/tests/jni-signatures/main.cpp
--- 1.6-2/tests/jni-signatures/main.cpp	1970-01-01 00:00:00.000000000 +0000
+++ 1.7-1/tests/jni-signatures/main.cpp	2020-06-28 23:30:42.000000000 +0000
@@ -0,0 +1,54 @@
+
+#define jclass int
+#define jint int
+#define jstring int
+
+// Crude approximation of #include <QAndroidJniObject> so we don't need QtAndroidExtras installed
+class QAndroidJniObject
+{
+    public:
+    QAndroidJniObject(const char *className, const char *signature);
+    QAndroidJniObject(jclass theClass, const char *signature);
+
+    template <typename T>
+    void callObjectMethod(const char *methodName, const char *signature);
+
+    template <typename T>
+    void callMethod(const char *methodName, const char *signature);
+
+    template <typename T>
+    static void callStaticMethod(const char *className, const char *methodName, const char *signature);
+
+    template <typename T>
+    static void callStaticObjectMethod(const char *className, const char *methodName, const char *signature);
+
+};
+
+namespace QtAndroid {
+    void androidActivity();
+};
+
+int main() {
+
+
+    QAndroidJniObject obj("/java/lang/String", "(");
+
+    jclass foo = 1;
+    QAndroidJniObject obj2(foo, "()V");
+
+    obj.callObjectMethod<int>("someMethod", "()V");
+    obj.callObjectMethod<int>("someMethod", "(III)V");
+    obj.callObjectMethod<int>("someMethod", "(III");
+
+    obj.callMethod<jint>("someMethod", "()V");
+    obj.callMethod<jint>("someMethod", "(III)V");
+    obj.callMethod<jint>("someMethod", "()Ljava/lang/String");
+
+    QAndroidJniObject::callStaticMethod<jint>("someClass;", "someMethod", "()Ljava/lang/String");
+
+    QAndroidJniObject::callStaticObjectMethod<int>("someClass", "someOtherMethod", "(II)");
+
+    obj.callObjectMethod<jstring>("className;", "toString");
+
+    QtAndroid::androidActivity();
+}
diff -pruN 1.6-2/tests/jni-signatures/main.cpp.expected 1.7-1/tests/jni-signatures/main.cpp.expected
--- 1.6-2/tests/jni-signatures/main.cpp.expected	1970-01-01 00:00:00.000000000 +0000
+++ 1.7-1/tests/jni-signatures/main.cpp.expected	2020-06-28 23:30:42.000000000 +0000
@@ -0,0 +1,9 @@
+jni-signatures/main.cpp:34:23: warning: Invalid class name: '/java/lang/String' [-Wclazy-jni-signatures]
+jni-signatures/main.cpp:34:23: warning: Invalid constructor signature: '(' [-Wclazy-jni-signatures]
+jni-signatures/main.cpp:41:5: warning: Invalid method signature: '(III' [-Wclazy-jni-signatures]
+jni-signatures/main.cpp:45:5: warning: Invalid method signature: '()Ljava/lang/String' [-Wclazy-jni-signatures]
+jni-signatures/main.cpp:47:5: warning: Invalid class name: 'someClass;' [-Wclazy-jni-signatures]
+jni-signatures/main.cpp:47:5: warning: Invalid method signature: '()Ljava/lang/String' [-Wclazy-jni-signatures]
+jni-signatures/main.cpp:49:5: warning: Invalid method signature: '(II)' [-Wclazy-jni-signatures]
+jni-signatures/main.cpp:51:5: warning: Invalid method name: 'className;' [-Wclazy-jni-signatures]
+jni-signatures/main.cpp:51:5: warning: Invalid method signature: 'toString' [-Wclazy-jni-signatures]
diff -pruN 1.6-2/tests/overloaded-signal/config.json 1.7-1/tests/overloaded-signal/config.json
--- 1.6-2/tests/overloaded-signal/config.json	1970-01-01 00:00:00.000000000 +0000
+++ 1.7-1/tests/overloaded-signal/config.json	2020-06-28 23:30:42.000000000 +0000
@@ -0,0 +1,7 @@
+{
+    "tests" : [
+        {
+            "filename" : "main.cpp"
+        }
+    ]
+}
diff -pruN 1.6-2/tests/overloaded-signal/main.cpp 1.7-1/tests/overloaded-signal/main.cpp
--- 1.6-2/tests/overloaded-signal/main.cpp	1970-01-01 00:00:00.000000000 +0000
+++ 1.7-1/tests/overloaded-signal/main.cpp	2020-06-28 23:30:42.000000000 +0000
@@ -0,0 +1,25 @@
+#include <QtCore/QObject>
+#include <QtCore/QString>
+
+class MyQObject : public QObject
+{
+    Q_OBJECT
+
+signals:
+    void ok(); // OK
+    void foo(); // Warn
+    void foo(int); // Warn
+    void bar(const QString &); // OK
+};
+
+class MyObject2 : public MyQObject
+{
+Q_OBJECT
+
+signals:
+    void bar(int); // Warn
+};
+
+void test()
+{
+}
diff -pruN 1.6-2/tests/overloaded-signal/main.cpp.expected 1.7-1/tests/overloaded-signal/main.cpp.expected
--- 1.6-2/tests/overloaded-signal/main.cpp.expected	1970-01-01 00:00:00.000000000 +0000
+++ 1.7-1/tests/overloaded-signal/main.cpp.expected	2020-06-28 23:30:42.000000000 +0000
@@ -0,0 +1,3 @@
+overloaded-signal/main.cpp:10:5: warning: signal foo is overloaded [-Wclazy-overloaded-signal]
+overloaded-signal/main.cpp:11:5: warning: signal foo is overloaded [-Wclazy-overloaded-signal]
+overloaded-signal/main.cpp:20:5: warning: signal bar is overloaded (with overloaded-signal/main.cpp:4:1) [-Wclazy-overloaded-signal]
diff -pruN 1.6-2/tests/qstring-arg/config.json 1.7-1/tests/qstring-arg/config.json
--- 1.6-2/tests/qstring-arg/config.json	2019-10-12 08:39:47.000000000 +0000
+++ 1.7-1/tests/qstring-arg/config.json	2020-06-28 23:30:42.000000000 +0000
@@ -9,6 +9,10 @@
                 {
                     "CLAZY_EXTRA_OPTIONS" : "qstring-arg-fillChar-overloads"
                 }
+        },
+        {
+            "filename" : "qlatin1string.cpp",
+            "minimum_qt_version" : 51400
         }
     ]
 }
diff -pruN 1.6-2/tests/qstring-arg/qlatin1string.cpp 1.7-1/tests/qstring-arg/qlatin1string.cpp
--- 1.6-2/tests/qstring-arg/qlatin1string.cpp	1970-01-01 00:00:00.000000000 +0000
+++ 1.7-1/tests/qstring-arg/qlatin1string.cpp	2020-06-28 23:30:42.000000000 +0000
@@ -0,0 +1,10 @@
+#include <QtCore/QString>
+
+void test()
+{
+    int a;
+    QLatin1String("%1").arg(1); // Warn
+    QLatin1String("%1").arg(a); // Warn
+    QLatin1String("%1").arg(QChar(1)); // OK
+    QLatin1String("%1").arg('a'); // OK
+}
diff -pruN 1.6-2/tests/qstring-arg/qlatin1string.cpp.expected 1.7-1/tests/qstring-arg/qlatin1string.cpp.expected
--- 1.6-2/tests/qstring-arg/qlatin1string.cpp.expected	1970-01-01 00:00:00.000000000 +0000
+++ 1.7-1/tests/qstring-arg/qlatin1string.cpp.expected	2020-06-28 23:30:42.000000000 +0000
@@ -0,0 +1,2 @@
+qstring-arg/qlatin1string.cpp:6:5: warning: Argument passed to QLatin1String::arg() will be implicitly cast to QChar [-Wclazy-qstring-arg]
+qstring-arg/qlatin1string.cpp:7:5: warning: Argument passed to QLatin1String::arg() will be implicitly cast to QChar [-Wclazy-qstring-arg]
diff -pruN 1.6-2/tests/qstring-comparison-to-implicit-char/config.json 1.7-1/tests/qstring-comparison-to-implicit-char/config.json
--- 1.6-2/tests/qstring-comparison-to-implicit-char/config.json	1970-01-01 00:00:00.000000000 +0000
+++ 1.7-1/tests/qstring-comparison-to-implicit-char/config.json	2020-06-28 23:30:42.000000000 +0000
@@ -0,0 +1,7 @@
+{
+    "tests" : [
+        {
+            "filename" : "main.cpp"
+        }
+    ]
+}
diff -pruN 1.6-2/tests/qstring-comparison-to-implicit-char/main.cpp 1.7-1/tests/qstring-comparison-to-implicit-char/main.cpp
--- 1.6-2/tests/qstring-comparison-to-implicit-char/main.cpp	1970-01-01 00:00:00.000000000 +0000
+++ 1.7-1/tests/qstring-comparison-to-implicit-char/main.cpp	2020-06-28 23:30:42.000000000 +0000
@@ -0,0 +1,11 @@
+#include <QtCore/QObject>
+#include <QtCore/QString>
+
+void test()
+{
+    QString s;
+    if (s == 5000) {} // Warn
+    if (s == 'a') {} // OK
+    if (s == "ok") {} // OK
+    if (s == s) {} // OK
+}
diff -pruN 1.6-2/tests/qstring-comparison-to-implicit-char/main.cpp.expected 1.7-1/tests/qstring-comparison-to-implicit-char/main.cpp.expected
--- 1.6-2/tests/qstring-comparison-to-implicit-char/main.cpp.expected	1970-01-01 00:00:00.000000000 +0000
+++ 1.7-1/tests/qstring-comparison-to-implicit-char/main.cpp.expected	2020-06-28 23:30:42.000000000 +0000
@@ -0,0 +1 @@
+qstring-comparison-to-implicit-char/main.cpp:7:9: warning: QString being compared to implicit QChar [-Wclazy-qstring-comparison-to-implicit-char]
diff -pruN 1.6-2/tests/qt6-qlatin1string-to-u/config.json 1.7-1/tests/qt6-qlatin1string-to-u/config.json
--- 1.6-2/tests/qt6-qlatin1string-to-u/config.json	1970-01-01 00:00:00.000000000 +0000
+++ 1.7-1/tests/qt6-qlatin1string-to-u/config.json	2020-06-28 23:30:42.000000000 +0000
@@ -0,0 +1,9 @@
+{
+    "tests" : [
+        {
+            "filename" : "main.cpp",
+            "qt_major_version": 6,
+            "has_fixits" : true
+        }
+    ]
+}
diff -pruN 1.6-2/tests/qt6-qlatin1string-to-u/main.cpp 1.7-1/tests/qt6-qlatin1string-to-u/main.cpp
--- 1.6-2/tests/qt6-qlatin1string-to-u/main.cpp	1970-01-01 00:00:00.000000000 +0000
+++ 1.7-1/tests/qt6-qlatin1string-to-u/main.cpp	2020-06-28 23:30:42.000000000 +0000
@@ -0,0 +1,27 @@
+#include <QtCore/QString>
+
+int totototo = 112233;
+
+void receivingQString(QString s1) {}
+void receivingQLatin1String(QLatin1String s1) {}
+
+
+#define PREFIX "foo"
+void test()
+{
+    QString s1 = QLatin1String("str");
+    QString s2 = QString(QLatin1String("s2"));
+    s1 += QLatin1String("str");
+    s1 = QLatin1String(true ? "foo" : "bar");
+    s1.append(QLatin1String("appending"));
+
+    receivingQString( QLatin1String("str"));
+    receivingQLatin1String( QLatin1String("latin"));
+
+    QLatin1String toto = QLatin1String("toto");
+
+    const char* myChar = "foo";
+    QString ww = QLatin1String(myChar); // should not be fixed
+    QString string_with_macro = QLatin1String(PREFIX "bar"); // should not be fixed
+
+}
diff -pruN 1.6-2/tests/qt6-qlatin1string-to-u/main.cpp.expected 1.7-1/tests/qt6-qlatin1string-to-u/main.cpp.expected
--- 1.6-2/tests/qt6-qlatin1string-to-u/main.cpp.expected	1970-01-01 00:00:00.000000000 +0000
+++ 1.7-1/tests/qt6-qlatin1string-to-u/main.cpp.expected	2020-06-28 23:30:42.000000000 +0000
@@ -0,0 +1,10 @@
+qt6-qlatin1string-to-u/main.cpp:12:18: warning: QLatin1String(const char *) ctor being called [-Wclazy-qt6-qlatin1string-to-u]
+qt6-qlatin1string-to-u/main.cpp:13:26: warning: QLatin1String(const char *) ctor being called [-Wclazy-qt6-qlatin1string-to-u]
+qt6-qlatin1string-to-u/main.cpp:14:11: warning: QLatin1String(const char *) ctor being called [-Wclazy-qt6-qlatin1string-to-u]
+qt6-qlatin1string-to-u/main.cpp:15:10: warning: QLatin1String(const char *) ctor being called [-Wclazy-qt6-qlatin1string-to-u]
+qt6-qlatin1string-to-u/main.cpp:16:15: warning: QLatin1String(const char *) ctor being called [-Wclazy-qt6-qlatin1string-to-u]
+qt6-qlatin1string-to-u/main.cpp:18:23: warning: QLatin1String(const char *) ctor being called [-Wclazy-qt6-qlatin1string-to-u]
+qt6-qlatin1string-to-u/main.cpp:19:29: warning: QLatin1String(const char *) ctor being called [-Wclazy-qt6-qlatin1string-to-u]
+qt6-qlatin1string-to-u/main.cpp:21:26: warning: QLatin1String(const char *) ctor being called [-Wclazy-qt6-qlatin1string-to-u]
+qt6-qlatin1string-to-u/main.cpp:24:18: warning: QLatin1String(const char *) ctor being called [-Wclazy-qt6-qlatin1string-to-u]
+qt6-qlatin1string-to-u/main.cpp:25:33: warning: QLatin1String(const char *) ctor being called [-Wclazy-qt6-qlatin1string-to-u]
diff -pruN 1.6-2/tests/qt6-qlatin1string-to-u/main.cpp.fixed.expected 1.7-1/tests/qt6-qlatin1string-to-u/main.cpp.fixed.expected
--- 1.6-2/tests/qt6-qlatin1string-to-u/main.cpp.fixed.expected	1970-01-01 00:00:00.000000000 +0000
+++ 1.7-1/tests/qt6-qlatin1string-to-u/main.cpp.fixed.expected	2020-06-28 23:30:42.000000000 +0000
@@ -0,0 +1,27 @@
+#include <QtCore/QString>
+
+int totototo = 112233;
+
+void receivingQString(QString s1) {}
+void receivingQLatin1String(QLatin1String s1) {}
+
+
+#define PREFIX "foo"
+void test()
+{
+    QString s1 = u"str";
+    QString s2 = QString(u"s2");
+    s1 += u"str";
+    s1 = true ? u"foo" : u"bar";
+    s1.append(u"appending");
+
+    receivingQString( u"str");
+    receivingQLatin1String( u"latin");
+
+    QLatin1String toto = u"toto";
+
+    const char* myChar = "foo";
+    QString ww = QLatin1String(myChar); // should not be fixed
+    QString string_with_macro = QLatin1String(PREFIX "bar"); // should not be fixed
+
+}
diff -pruN 1.6-2/tests/run_tests.py 1.7-1/tests/run_tests.py
--- 1.6-2/tests/run_tests.py	2019-10-12 08:39:47.000000000 +0000
+++ 1.7-1/tests/run_tests.py	2020-06-28 23:30:42.000000000 +0000
@@ -4,7 +4,7 @@ import sys, os, subprocess, string, re,
 import shutil
 from threading import Thread
 from sys import platform as _platform
-
+import platform
 
 # cd into the folder containing this script
 os.chdir(os.path.realpath(os.path.dirname(sys.argv[0])))
@@ -455,7 +455,7 @@ def files_are_equal(file1, file2):
 
         return lines1 == lines2
     except Exception as ex:
-        print("Errot comparing files:" + str(ex))
+        print("Error comparing files:" + str(ex))
         return False
 
 def compare_files(expects_failure, expected_file, result_file, message):
@@ -586,6 +586,10 @@ def run_unit_test(test, is_standalone):
     result_file = filename + ".result"
     expected_file = filename + ".expected"
 
+    # Some tests have different output on 32 bit
+    if platform.architecture()[0] == '32bit' and os.path.exists(expected_file + '.x86'):
+        expected_file = expected_file + '.x86'
+
     if is_standalone and test.isScript():
         return True
 
diff -pruN 1.6-2/tests/virtual-call-ctor/main.cpp 1.7-1/tests/virtual-call-ctor/main.cpp
--- 1.6-2/tests/virtual-call-ctor/main.cpp	2019-10-12 08:39:47.000000000 +0000
+++ 1.7-1/tests/virtual-call-ctor/main.cpp	2020-06-28 23:30:42.000000000 +0000
@@ -1,4 +1,4 @@
-
+#include <QtCore/QObject>
 
 
 
@@ -29,3 +29,13 @@ struct A
     {
     }
 };
+
+class B : public QObject {
+public:
+    B() {
+        QObject::connect(this, &QObject::destroyed, this, [this] {
+            some_virtual_method();
+        });
+    }
+     virtual void some_virtual_method() = 0;
+};
